<?php
/*
Plugin Name: Paypal Promocode - version 1.6.3
Plugin URI: http://fischercreativemedia.com/wordpress-plugins/paypal-promo-code-plugin/
Description: Allows easy addition of Paypal buttons with PromoCode in pages and posts. Allows creation of PayPal BuyNow/PayNow Buttons for Products and also has integrated PayPal Instant Payment Notification.
Version: 1.6.3
Author: Don Fischer, Fischer Creative Media, LLC
Author URI: http://www.fischercreativemedia.com/
Author Email: dfischer@fischercreativemedia.com
Text Domain: paypal-promo-plugin-locale
Domain Path: /lang
License: GPL2

  Copyright 2009-2018 (dfischer@fischercreativemedia.com)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2, as 
  published by the Free Software Foundation.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  
*/
if ( ! defined( 'ABSPATH' ) )
	die( "Can't load this file directly" );

//AVAILABLE ACTIONS & FILTERS
//'pppcode-make-pppviewcart'	/* args (4): $form (html): button form HTML; $buttonUrlshort (string): file name of button image;$buttonUrl (url): full URL to button image;$pp_emailadd (email): PayPal Email Address for account holder;*/
//'pppcode-button-url' 			/* args (1): $url (url) - full URL of button image file */
//'pppcode-button-url-short' 	/* args (1): $url (string) - URL of just the image file (not full URI) */
//'pppcode-update-settings'		/* args (1): $ppp_options (array): options just before update; */
//'pppcode-price-symbol'		/* args (1): $symbol (string ASCII): current symbol used; return ASCII code for symbol, i.e., &#36; is for $  */
//'ppp_default_options'			/* args (1): $ppp_options (array): default options on setup; */


//Required for plugin update
require_once( plugin_dir_path( __FILE__ ).'/updates/plugin-update-checker.php' );
new FCMPluginUpdateChecker_1_6 ( 'http://graphiccaffeine.com/wp-admin/admin-ajax.php', __FILE__ );

class PayPalPromoCodePlugin {
	public $fileis;
	public $pppcodequery;
	public $promocodenum;
	public $promocode;
	public $ppplocation;
	public $buttontype;
	public $_PPPROMOFOLDER;
	public $_PPPROMO_ABSPATH;
	public $_PPPROMO_URLPATH;
	public $_PPPVERSION; 
	public $_PPP_DBVERSION;
	public $procodesession;
	public $ppp_options;
	public $curSym;

	function __construct() {
		if( !is_admin() || ( defined('DOING_AJAX') && DOING_AJAX )){
			if (!session_id())
				session_start(); 
		}
		$this->_PPPVERSION		= '1.6.1'; //Plugin Version
		$this->_PPP_DBVERSION	= '1.5.6'; //Database Version
		$this->buttontype		= "_xclick"; //types: _donations, _xclick-subscriptions, _cart, _xclick
		$this->_PPPROMOFOLDER	= plugin_basename( dirname( __FILE__ ) ) ;
		$this->_PPPROMO_ABSPATH	= plugin_dir_path( __FILE__ ).'/' ;
		$this->_PPPROMO_URLPATH	= plugins_url( '/' , __FILE__ );
		$this->fileis 			= plugin_basename( __FILE__ );
		$this->ppplocation 		= $this->_PPPROMO_URLPATH.'paypalpromo.php';
		$this->pppcodequery		= isset( $_REQUEST['pppcode'] ) && !empty( $_REQUEST['pppcode'] ) ? sanitize_text_field( $_REQUEST['pppcode'] ) : '';
		$this->promocodenum		= isset( $_REQUEST['pp_promocode_num'] ) && !empty( $_REQUEST['pp_promocode_num'] ) ? (int) $_REQUEST['pp_promocode_num'] : 0;
		$this->promocode		= isset( $_REQUEST['pp_promocode']  )&& !empty( $_REQUEST['pp_promocode'] ) ? sanitize_text_field( $_REQUEST['pp_promocode'] ) : null;
		$this->promocode 		= empty($this->promocode) && !empty($this->pppcodequery) ? $this->pppcodequery : $this->promocode;
		if($this->promocode != '') //set up a day cookie
			setcookie("promocode", $this->promocode,  time() + (86400 * 30), "/");
		if($this->promocode == '' && isset($_COOKIE["promocode"])) 	
			$this->promocode = $_COOKIE["promocode"];
		
		$this->curSym			= array( 'ALL'=>'Lek','AFN'=>'&#1547;','ARS'=>'$','AWG'=>'ƒ','AUD'=>'$','AZN'=>'&#1084;&#1072;&#1085;','BSD'=>'$','BBD'=>'$','BYN'=>'Br','BZD'=>'BZ$','BMD'=>'$','BOB'=>'$b','BAM'=>'KM','BWP'=>'P','BGN'=>'&#1083;&#1074;','BRL'=>'R$','BND'=>'$','KHR'=>'&#6107;','CAD'=>'$','KYD'=>'$','CLP'=>'$','CNY'=>'¥','COP'=>'$','CRC'=>'&#8353;','HRK'=>'kn','CUP'=>'&#8369;','CZK'=>'K&#269;','DKK'=>'kr','DOP'=>'RD$','XCD'=>'$','EGP'=>'£','SVC'=>'$','EUR'=>'€','FKP'=>'£','FJD'=>'$','GHS'=>'¢','GIP'=>'£','GTQ'=>'Q','GGP'=>'£','GYD'=>'$','HNL'=>'L','HKD'=>'$','HUF'=>'Ft','ISK'=>'kr','INR'=>'','IDR'=>'Rp','IRR'=>'&#65020;','IMP'=>'£','ILS'=>'&#8362;','JMD'=>'J$','JPY'=>'¥','JEP'=>'£','KZT'=>'&#1083;&#1074;','KPW'=>'&#8361;','KRW'=>'&#8361;','KGS'=>'&#1083;&#1074;','LAK'=>'&#8365;','LBP'=>'£','LRD'=>'$','MKD'=>'&#1076;&#1077;&#1085;','MYR'=>'RM','MUR'=>'&#8360;','MXN'=>'$','MNT'=>'&#8366;','MZN'=>'MT','NAD'=>'$','NPR'=>'&#8360;','ANG'=>'ƒ','NZD'=>'$','NIO'=>'C$','NGN'=>'&#8358;','KPW'=>'&#8361;','NOK'=>'kr','OMR'=>'&#65020;','PKR'=>'&#8360;','PAB'=>'B/.','PYG'=>'Gs','PEN'=>'S/.','PHP'=>'&#8369;','PLN'=>'z&#322;','QAR'=>'&#65020;','RON'=>'lei','RUB'=>'&#8381;','SHP'=>'£','SAR'=>'&#65020;','RSD'=>'&#1044;&#1080;&#1085;.','SCR'=>'&#8360;','SGD'=>'$','SBD'=>'$','SOS'=>'S','ZAR'=>'R','KRW'=>'&#8361;','LKR'=>'&#8360;','SEK'=>'kr','CHF'=>'CHF','SRD'=>'$','SYP'=>'£','TWD'=>'NT$','THB'=>'&#3647;','TTD'=>'TT$','TRY'=>'','TVD'=>'$','UAH'=>'&#8372;','GBP'=>'£','USD'=>'$','UYU'=>'$U','UZS'=>'&#1083;&#1074;','VEF'=>'Bs','VND'=>'&#8363;','YER'=>'&#65020;','ZWD'=>'Z$');			//check if PromoCode is assigned to this button, otherwise don't display promocode box at all.
		$_SESSION['procode'] 	= !empty($this->promocode) && !empty($this->promocode) ? $this->promocode : null;
		$this->procodesession	= $this->promocode;
		$this->ppp_options		= $this->ppp_default_options();
		if ( isset( $_REQUEST['pp_promoclear'] ) ){
			unset( $_SESSION['procode'] );
			if( isset( $_SERVER['REQUEST_URI'] ) && $_SERVER['REQUEST_URI'] != '' )
				wp_redirect( $_SERVER['REQUEST_URI'], 302 );
		}
		require_once( plugin_dir_path( __FILE__ ).'/includes/pppromo-add-tmce.php' );
		add_action( 'admin_menu', array( $this, 'register_custom_menu_page'));
		add_action( 'init', array( $this, 'plugin_check_add_edit' ));
		add_action( 'plugins_loaded', array( $this, 'plugin_load_textdomain' ) );
		add_action( 'query_vars',array($this,'ppp_queryhook'));
		add_action( 'wp',array($this,'ppp_parse_request'));
		add_action( 'wp_enqueue_scripts', array( $this, 'register_plugin_scripts' ), 999 );
		add_action( 'wp_ajax_nopriv_pppcode_ajax_helper', array( $this, 'pppcode_ajax_helper' )  );		// register ajax
		add_action( 'wp_ajax_pppcode_ajax_helper', array( $this, 'pppcode_ajax_helper' )  );		// register ajax
		add_shortcode('pppromo', array($this,'render_shortcode_pppromo'));
	    add_shortcode('paypalpromo', array($this,'render_shortcode_pppromo'));
	    add_shortcode('pppviewcart', array($this,'render_shortcode_pppromocart'));
		add_filter('paypal-promo-price-symbol' ,array($this,'fix_currency_symbols'), 10, 2);
		register_activation_hook( __FILE__, array( $this, 'activate' ) );
		register_deactivation_hook( __FILE__, array( $this, 'deactivate' ) );
	}
	function fix_currency_symbols($symbol ='', $curcode = ''){
		if($curcode == '')
			$curcode = getMultiOption('ppp_options','currencyCode');
		$symbols_array = array('ALL'=>'&#76;&#101;&#107;','AFN'=>'&#1547;','ARS'=>'&#36;','AWG'=>'&#402;','AUD'=>'&#36;','AZN'=>'&#1084;&#1072;&#1085;','BSD'=>'&#36;','BBD'=>'&#36;','BYN'=>'&#66;&#114;','BZD'=>'&#66;&#90;&#36;','BMD'=>'&#36;','BOB'=>'&#36;&#98;','BAM'=>'&#75;&#77;','BWP'=>'&#80;','BGN'=>'&#1083;&#1074;','BRL'=>'&#82;&#36;','BND'=>'&#36;','KHR'=>'&#6107;','CAD'=>'&#36;','KYD'=>'&#36;','CLP'=>'&#36;','CNY'=>'&#165;','COP'=>'&#36;','CRC'=>'&#8353;','HRK'=>'&#107;&#110;','CUP'=>'&#8369;','CZK'=>'&#75;&#269;','DKK'=>'&#107;&#114;','DOP'=>'&#82;&#68;&#36;','XCD'=>'&#36;','EGP'=>'&#163;','SVC'=>'&#36;','EUR'=>'&#8364;','FKP'=>'&#163;','FJD'=>'&#36;','GHS'=>'&#162;','GIP'=>'&#163;','GTQ'=>'&#81;','GGP'=>'&#163;','GYD'=>'&#36;','HNL'=>'&#76;','HKD'=>'&#36;','HUF'=>'&#70;&#116;','ISK'=>'&#107;&#114;','INR'=>'&#8377;','IDR'=>'&#82;&#112;','IRR'=>'&#65020;','IMP'=>'&#163;','ILS'=>'&#8362;','JMD'=>'&#74;&#36;','JPY'=>'&#165;','JEP'=>'&#163;','KZT'=>'&#1083;&#1074;','KPW'=>'&#8361;','KRW'=>'&#8361;','KGS'=>'&#1083;&#1074;','LAK'=>'&#8365;','LBP'=>'&#163;','LRD'=>'&#36;','MKD'=>'&#1076;&#1077;&#1085;','MYR'=>'&#82;&#77;','MUR'=>'&#8360;','MXN'=>'&#36;','MNT'=>'&#8366;','MZN'=>'&#77;&#84;','NAD'=>'&#36;','NPR'=>'&#8360;','ANG'=>'&#402;','NZD'=>'&#36;','NIO'=>'&#67;&#36;','NGN'=>'&#8358;','NOK'=>'&#107;&#114;','OMR'=>'&#65020;','PKR'=>'&#8360;','PAB'=>'&#66;&#47;&#46;','PYG'=>'&#71;&#115;','PEN'=>'&#83;&#47;&#46;','PHP'=>'&#8369;','PLN'=>'&#122;&#322;','QAR'=>'&#65020;','RON'=>'&#108;&#101;&#105;','RUB'=>'&#8381;','SHP'=>'&#163;','SAR'=>'&#65020;','RSD'=>'&#1044;&#1080;&#1085;&#46;','SCR'=>'&#8360;','SGD'=>'&#36;','SBD'=>'&#36;','SOS'=>'&#83;','ZAR'=>'&#82;','LKR'=>'&#8360;','SEK'=>'&#107;&#114;','CHF'=>'&#67;&#72;&#70;','SRD'=>'&#36;','SYP'=>'&#163;','TWD'=>'&#78;&#84;&#36;','THB'=>'&#3647;','TTD'=>'&#84;&#84;&#36;','TRY'=>'&#8378;','TVD'=>'&#36;','UAH'=>'&#8372;','GBP'=>'&#163;','USD'=>'&#36;','UYU'=>'&#36;&#85;','UZS'=>'&#1083;&#1074;','VEF'=>'&#66;&#115;','VND'=>'&#8363;','YER'=>'&#65020;','ZWD'=>'&#90;&#36;');	
		$newSymbol = isset($symbols_array[strtoupper($curcode)]) ? $symbols_array[strtoupper($curcode)] : '';
		if($newSymbol != '')
			return $newSymbol;
		return $symbol;
	}
	function plugin_check_add_edit(){
		$page = isset($_REQUEST['page']) && $_REQUEST['page'] != '' ? $_REQUEST['page'] : '';
		$mode = isset($_REQUEST['mode']) && $_REQUEST['mode'] != '' ? $_REQUEST['mode'] : '';
		$addBT = isset( $_POST['pppcodebtn_addnew'] ) && $_POST['pppcodebtn_addnew'] != '' ? true : false;
		$addPC = isset( $_POST['pppcode_addnew'] ) && $_POST['pppcode_addnew'] != '' ? true : false;
		if ($page == 'ppaddcode' && $mode == 'pppcode_addnew' && $addPC ) {
			$this->pppcode_insertnew();
		}elseif( $page == 'ppaddbutton' && $mode ==  'pppcodebtn_addnew' && $addBT ) {
			$this->pppcodebtn_insertnew();
		}

	}
	function return_ajax_response($method, $msg = '', $active = ''){
		$tempArr = array( 'type' => $method, 'message' => $msg );
		if($active != '')
			$tempArr['active'] = $active;
		echo json_encode( $tempArr );
		exit;
	}
	
	function pppcode_ajax_helper(){
		if ( !wp_verify_nonce( $_REQUEST['security'], "pppcode_ajax_helper_654d6sghj")){
			$this->return_ajax_response('error',__('No Permissions'));
		}else{
			//session_start();
			$method 	= isset($_REQUEST['method']) ? sanitize_text_field($_REQUEST['method']) : '';
			$promoStr 	= isset($_REQUEST['promocode']) ? sanitize_text_field($_REQUEST['promocode']) : '';
			$bttnID 	= isset($_REQUEST['btnid']) ? sanitize_text_field($_REQUEST['btnid']) : '';
			switch ($method){
				case 'apply_promocode':	
					$data = $this->ajax_apply_promo( $promoStr, $bttnID );
					$this->return_ajax_response($data['type'], $data['message'], $data['active']);
					break;
				case 'clear_promocode':
					$data = $this->ajax_clear_promo( $promoStr, $bttnID );
					$this->return_ajax_response($data['type'], $data['message'], $data['active']);
					break;
			}
		}
		return_ajax_response('error','Unknown Error');
	}
	
	function ajax_apply_promo($promo = '', $btnid = 0){
		if( $btnid != 0 && $btnid != '' ){
			global $wpdb;
			$type			= 0;
			$disc			= 0;
			$dscr			= serialize(array());
			$curSym			= $this->curSym;;
			$ppCodeCheck 	= $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}pppromo` WHERE `ppname` = '{$promo}' ORDER BY `ppid` DESC LIMIT 1");
			if(!is_array($ppCodeCheck) || empty($ppCodeCheck))
				return array('type' => 'status', 'message' => 'not valid');
			if( is_array( $ppCodeCheck ) && !empty( $ppCodeCheck ) ){
				foreach( $ppCodeCheck as $k => $v ){
					$start 	= $v->sdate;
					$end	= $v->edate;
					$dscr	= $v->description;
					$type	= (int) $v->ppdiscounttype;
					$disc	= $v->ppdiscount;
					$dscr	= $v->description;
					if( !is_array(maybe_unserialize($dscr)) || $dscr == '' )
						return array('type' => 'status', 'message' => 'no buttons assigned.');
					//is active?
					if( strtotime(date('Y-m-d H:i:j')) < strtotime($start.' 00:00:01'))
						return array('type' => 'status', 'message' => 'not active');
					//is expired?
					if( strtotime(date('Y-m-d H:i:j')) > strtotime($end.' 23:59:59'))
						return array('type' => 'status', 'message' => 'expired');
					//has buttons assigned?		
				}
			}	
			if($promo == '' && isset($_COOKIE['promocode'])){
				$this->procodesession	= $_COOKIE['promocode'];
			}else{
				$this->procodesession = $promo;
				setcookie("promocode", $promo, time() + (86400 * 30), "/");

			}
			//echo $promo;
			$promoData 		= array();
			$pppButtons 	= $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}pppromoproducts` order by `pid` DESC");
			$applies 	= false;
			if( is_array($pppButtons) && !empty($pppButtons) ){
				foreach ( $pppButtons as $k => $brow ){
					$currency_code = $brow->currency_code != '' ? $brow->currency_code : getMultiOption('ppp_options','currencyCode');
					if( in_array( $brow->pid, unserialize( $dscr ) ) ){
						$amount 	= $brow->amount;
						$applies 	= true;
						$workingnum	= $disc;
						if( $type == 1 ){  /* this is Percent Off*/
							$newamount 	= round( $amount - ( $workingnum * $amount ) / 100, 2 );
							$pcodemsg	= '<span style="color:#FF0000;">'.$promo.' - '.$workingnum.'% '.__('Off Regular Price','paypal-promo-plugin-locale').'</span>';
							$amount		= $newamount;
						}elseif( $type == 2 ){ 
							if($amount >= $workingnum){ //$Off
								$newamount 	= $amount - $workingnum; 
								$pcodemsg 	= '<span style="color:#FF0000;">'.$promo.' - '.apply_filters('paypal-promo-price-symbol','$',$currency_code).$workingnum.' '.__('Off Regular Price','paypal-promo-plugin-locale').'</span>';
								$amount 	= $newamount;
							}else{
								$newamount 	= $amount;
								$pcodemsg 	= '<span style="color:#FF0000;">'.$promo.' - '.apply_filters('paypal-promo-price-symbol','$',$currency_code).$workingnum.' '.__('Off Regular Price','paypal-promo-plugin-locale').'</span>';
								$amount 	= $newamount;
							}
						}elseif( $type == 3 ){  //$set price
								$newamount	= $workingnum; 
								$pcodemsg	= '<span style="color:#FF0000;">'.$promo.' - '.__('Item for only ','paypal-promo-plugin-locale').apply_filters('paypal-promo-price-symbol','$',$currency_code).number_format($newamount,2).' ('.__('normally ','paypal-promo-plugin-locale').$curSym[$currency_code].$amount.' - '.__('a savings of ','paypal-promo-plugin-locale').$curSym[$currency_code].($amount-$newamount).')</span>';
								$amount		= $newamount;
						}
					}else{
						$applies 	= false;
						$amount 	= $brow->amount;
						$pcodemsg	= 'Does Not Apply To This Item.';
					}
					$promoData[$brow->pid] = array('applies'=> $applies, 'id' => $brow->pid, 'name' => $brow->item_name, 'reg_amt' => apply_filters('paypal-promo-price-symbol','$',$currency_code).number_format($brow->amount,2), 'amt' => $curSym[$currency_code].number_format($amount,2), 'pcodemsg'=> $pcodemsg);
				}
			}
			return array('active' => $btnid, 'type' => 'ok', 'message' => $promoData );
		}else{
			return array('type' => 'error', 'message' => 'no button id');
		}
	}
	
	function ajax_clear_promo($promo = '', $btnid = 0){
		global $wpdb;
		$currPromo	= $promo != '' ? $promo : '';
		$currPromo  = $currPromo == '' && isset($_SESSION['procode']) && $_SESSION['procode'] != '' ? $_SESSION['procode'] : $currPromo;
		$tempBut = array();
		if($currPromo == ''){
			return array('type' => 'error', 'message' => 'no promocode in session');
		}else{
			$curSym			= $this->curSym;
			$pppButtons 	= $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}pppromo` WHERE `ppname` = '{$currPromo}' ORDER BY `ppid` DESC LIMIT 1");
			//echo '<pre style="">output:<br/>'.print_r($pppButtons,true).'</pre>';
				//exit;
			if(is_array($pppButtons) && ! empty($pppButtons)){
				foreach($pppButtons as $k => $v){
					$dscr	= $v->description;
					if( !is_array(maybe_unserialize($dscr)) || $dscr == '' ){
						return array('type' => 'status', 'message' => 'no buttons assigned.');
					}else{
						$tempBut = maybe_unserialize($dscr);
					}
				}
			}
			//echo '<pre style="">$tempBut:<br/>'.print_r($tempBut,true).'</pre>';
			if( $btnid != 0 && $btnid != '' ){
				global $wpdb;
				$promoData 		= array();
				$pppButtons 	= $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}pppromoproducts` WHERE `pid` = '{$btnid}' order by `pid` DESC");
				if( is_array($pppButtons) && !empty($pppButtons) ){
					foreach ( $pppButtons as $brow ){
						$currency_code = $brow->currency_code;
						$promoData[$brow->pid] = array( 'id' => $brow->pid, 'reg_amt' => $curSym[$currency_code].number_format($brow->amount,2), 'name' => $brow->item_name);
					}
				}
				return array('type' => 'ok', 'active' => $btnid, 'message' => $promoData );
			}else{
				return array('type' => 'error', 'message' => 'no button id');
			
			}
		}
	}
	function checkPromoCodeAjax($pptocheck){
		//check to see if PromoCode exists
		if( (string) $pptocheck == '' )
			return false;
			
		global $wpdb;
		$ppCodeCheck = $wpdb->get_results("SELECT * FROM `{$wpdb->prefix}pppromo` WHERE `ppname` = '{$pptocheck}' ");
		if( !$ppCodeCheck )
			return false;
		return true;
		return true;
	}
	
	/**
	 * Load plugin textdomain.
	 *
	 * @return null
	 * @since 1.0
	 */
	function plugin_load_textdomain() {
		load_plugin_textdomain( 'paypal-promo-plugin-locale', false, dirname( plugin_basename( __FILE__ ) ) . '/lang' ); 
	}

	public function activate( $network_wide ) {
		global $wpdb, $wp_roles, $wp_version;
		if(get_option("ppp_db_complete") <= 148 || get_option("ppp_db_complete")=='' )
			$theupgrade = $this->ppp_upgrade('1.4.8');//see if DB needs upgrade
		if ( version_compare($wp_version, '2.7', '>=' )) 
			require_once(ABSPATH . 'wp-admin/includes/upgrade.php');//check WP version
		$charset_collate = '';
		$charset_collate2 = '';
		//check MYSQL version
		if ( function_exists('mysql_get_server_info') && version_compare( mysql_get_server_info(), '4.1.0', '>=') ) {
			if ( ! empty($wpdb->charset) ){
				$charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
				$charset_collate2 = "DEFAULT CHARSET=$wpdb->charset";
			}
			if ( ! empty($wpdb->collate) ){
				$charset_collate .= " COLLATE $wpdb->collate";
				$charset_collate2 .= "";
			}
		}
		//table names for this plugin	
		$pppromo			= $wpdb->prefix . 'pppromo'; //promocode table
		$pppromoproducts	= $wpdb->prefix . 'pppromoproducts'; //button table
		$ppcart_info		= $wpdb->prefix . 'paypal_cart_info'; //PayPal INS cart
		$ppsubscribe_info	= $wpdb->prefix . 'paypal_subscription_info'; //PayPal INS subscriptions
	 	$pppayment_info		= $wpdb->prefix . 'paypal_payment_info'; //PayPal INS payments
	   	$nnd 				= 'NOT NULL DEFAULT';
	   	$nn 				= 'NOT NULL';
		$dn 				= 'DEFAULT NULL';
		$ctne 				= 'CREATE TABLE IF NOT EXISTS';
		$vc255				= 'varchar(255)';
		$vc100				= 'varchar(100)';
		$vc50				= 'varchar(50)';
		$vc20				= 'varchar(20)';
		$vc10				= 'varchar(10)';
		
		//create tables if they do not exist 
			if( $wpdb->get_var("show tables like '{$pppromo}'") != $pppromo ) {
				$sql = "CREATE TABLE {$pppromo} ( ppid BIGINT(20) {$nn} AUTO_INCREMENT, ppname {$vc255} {$nn}, description MEDIUMTEXT NULL,ppdiscount BIGINT(20) DEFAULT '0' {$nn}, ppdiscounttype TINYINT NULL DEFAULT '0', exclude TINYINT NULL DEFAULT '0', sdate DATE, edate DATE, wasused BIGINT(20) DEFAULT '0' {$nn}, PRIMARY KEY ppid (ppid)) $charset_collate;";
				dbDelta($sql);
				$this->ppp_default_options();
				add_option("ppp_db_version", $this->_PPP_DBVERSION);
			}
			if($wpdb->get_var( "show tables like '{$pppromoproducts}'") != $pppromoproducts ) {
				$sql = "CREATE TABLE {$pppromoproducts} ( pid BIGINT(20) {$nn} AUTO_INCREMENT , item_name {$vc255} {$nn}, item_num {$vc255} {$nn}, special_instr TINYINT NULL DEFAULT '0', amount DECIMAL(10,2) DEFAULT '0' {$nn}, shipping TINYINT NULL DEFAULT '0', shipping_amt DECIMAL(10,2) DEFAULT '0' {$nn}, return_url {$vc255} NULL, cancel_url {$vc255} NULL, currency_code VARCHAR(4) {$nn}, button_type INT(5) {$nnd} '1', pp_emailadd {$vc255} {$nn}, PRIMARY KEY pid (pid) ) $charset_collate;";
				dbDelta($sql);
				$this->ppp_default_options();
				add_option("ppp_db_version", $this->_PPP_DBVERSION);
				add_option("ppp_shouldbe_version", $myplugversion);
			}
		//if table does exist, fix DECIMAL Declaration for amount column (wrong in v1.0)
			if($wpdb->get_var( "show tables like '{$pppromoproducts}'" ) != $pppromoproducts ) {
				$wpdb->query( "ALTER TABLE {$pppromoproducts} CHANGE `button_type` `button_type` INT( 5 ) {$nnd} '1'" );
			}
		//Create PayPal Tables 
			if($wpdb->get_var("show tables like '{$ppcart_info}'") != $ppcart_info ) {
				/* # Table structure for table `paypal_cart_info` # */
				$sql = "{$ctne} {$ppcart_info} (`id` int(11) {$nn} AUTO_INCREMENT, `txnid` varchar(30) {$nnd} '', `itemname` {$vc255} {$nnd} '', `itemnumber` {$vc50} {$dn}, `os0` {$vc20} {$dn}, `on0` {$vc50} {$dn}, `os1` {$vc20} {$dn}, `on1` {$vc50} {$dn}, `quantity` char(3) {$nnd} '', `invoice` {$vc255} {$nnd} '', `custom` {$vc255} {$nnd} '', PRIMARY KEY (`id`)) ENGINE=MyISAM  $charset_collate2 ;";
				dbDelta($sql);
			}
			if($wpdb->get_var("show tables like '{$ppsubscribe_info}'" ) != $ppsubscribe_info ) {
				/* # Table structure for table `paypal_subscription_info` # */
				$sql = "{$ctne} {$ppsubscribe_info} (`id` int(11) {$nn} AUTO_INCREMENT, `subscr_id` {$vc255} {$nnd} '', `sub_event` {$vc50} {$nnd} '', `subscr_date` {$vc255} {$nnd} '', `subscr_effective` {$vc255} {$nnd} '', `period1` {$vc255} {$nnd} '', `period2` {$vc255} {$nnd} '', `period3` {$vc255} {$nnd} '', `amount1` {$vc255} {$nnd} '', `amount2` {$vc255} {$nnd} '', `amount3` {$vc255} {$nnd} '', `mc_amount1` {$vc255} {$nnd} '', `mc_amount2` {$vc255} {$nnd} '', `mc_amount3` {$vc255} {$nnd} '', `recurring` {$vc255} {$nnd} '', `reattempt` {$vc255} {$nnd} '', `retry_at` {$vc255} {$nnd} '', `recur_times` {$vc255} {$nnd} '', `username` {$vc255} {$nnd} '', `password` {$vc255} {$dn}, `payment_txn_id` {$vc50} {$nnd} '', `subscriber_emailaddress` {$vc255} {$nnd} '', `datecreation` date {$nnd} '0000-00-00', PRIMARY KEY (`id`)) ENGINE=MyISAM $charset_collate2;";
				dbDelta($sql);
			}
			if($wpdb->get_var("show tables like '{$pppayment_info}'" ) != $pppayment_info ) {
				/*# Table structure for table `paypal_payment_info` #*/
				$sql= "{$ctne} {$pppayment_info} (`tid` int(11) {$nn} AUTO_INCREMENT, `firstname` {$vc100} {$nnd} '', `lastname` {$vc100} {$nnd} '', `buyer_email` {$vc100} {$nnd} '', `street` {$vc100} {$nnd} '', `city` {$vc50} {$nnd} '', `state` char(3) {$nnd} '', `zipcode` varchar(11) {$nnd} '', `memo` {$vc255} {$dn}, `itemname` {$vc255} {$dn}, `itemnumber` {$vc50} {$dn}, `os0` {$vc20} {$dn}, `on0` {$vc50} {$dn}, `os1` {$vc20} {$dn}, `on1` {$vc50} {$dn}, `quantity` char(3) {$dn}, `paymentdate` {$vc50} {$nnd} '', `paymenttype` {$vc10} {$nnd} '', `txnid` varchar(30) {$nnd} '', `mc_gross` varchar(6) {$nnd} '', `mc_fee` varchar(5) {$nnd} '', `paymentstatus` varchar(15) {$nnd} '', `pendingreason` {$vc10} {$dn}, `txntype` {$vc10} {$nnd} '', `tax` {$vc10} {$dn}, `mc_currency` varchar(5) {$nnd} '', `reasoncode` {$vc20} {$nnd} '', `custom` {$vc255} {$nnd} '', `country` {$vc20} {$nnd} '', `datecreation` date {$nnd} '0000-00-00', PRIMARY KEY (`tid`), UNIQUE KEY `tid` (`tid`)) ENGINE=MyISAM  {$charset_collate2};";
				dbDelta($sql);
			}
			if($wpdb->get_var("show tables like '{$pppromoproducts}'" ) != $pppromoproducts ) {
				// check again and leave error if not able to create
				update_option( "pppcode_init_check", __('PayPal Promocode : Tables could not created, please check your database settings', 'paypal-promo-plugin-locale') );
			}
		return;
	}
	
	private function deactivate( $network_wide ) {
		// Define deactivation functionality here	
		return;	
	}
		
	private function ppr_uninstall( $network_wide ) {
		//delete_option( "pppcode_init_check" );
		return;
	}
	
	public function register_custom_menu_page(){
		$modes 	= array('pppcode_rem','pppcodebtn_rem','pppcodeeditdo','pppcodebtn_editdo','pppcode_addnew','pppcodebtn_addnew');
		$mode 	= isset( $_REQUEST['mode'] ) && $_REQUEST['mode'] != '' && in_array( sanitize_text_field( $_REQUEST['mode'] ), $modes ) ? sanitize_text_field( $_REQUEST['mode'] ) : '';
		$ppid 	= isset( $_REQUEST['ppid'] ) && (int) $_REQUEST['ppid'] > 0 ? (int) $_REQUEST['ppid'] : 0;
		if( $ppid != 0 && !empty( $mode ) ){
			switch( $mode ){
				case 'pppcode_rem':
					$this->pppcode_removetst( $ppid );
					break;
				case  'pppcodebtn_rem':
					$this->pppcodebtn_removetst( $ppid );
					break;
				case 'pppcodeeditdo':
					$this->pppcode_editdo( $ppid );
					break;
				case 'pppcodebtn_editdo':
					$this->pppcodebtn_editdo( $ppid );
					break;
				case 'pppcode_addnew':
					$this->pppcode_insertnew( $ppid );
					break;
				case 'pppcodebtn_addnew':
					$this->pppcodebtn_insertnew( $ppid );
					break;
			}
		}
		//add_filter( 'post_updated_messages', array( $this,'paypal_button_updated_messages' ));
		add_menu_page( __( 'PayPal Promo Code Plugin', 'paypal-promo-plugin-locale' ), 'PayPal Codes', 'manage_options', 'pppromo-page', array( $this, 'pppromoadminmain' ),'none', '23.f' );
		add_submenu_page('pppromo-page', __('PayPal Promo Code Add Button','paypal-promo-plugin-locale'), __('New PayPal Button','paypal-promo-plugin-locale'), 'manage_options', 'ppaddbutton', array($this,'pppcodebtn_adminpage'));
		add_submenu_page('pppromo-page', __('PayPal Promo Code Add Promo Code','paypal-promo-plugin-locale'), __('New PayPal Code','paypal-promo-plugin-locale'), 'manage_options', 'ppaddcode', array($this,'pppcode_adminpage'));
		add_submenu_page('pppromo-page', __('PayPal Promo Code Options','paypal-promo-plugin-locale'), __('PP Promo Options','paypal-promo-plugin-locale'), 'manage_options', 'ppaddset', array($this,'pppcode_setpage'));
		add_submenu_page('pppromo-page', __('PayPal Promo Code Tracking','paypal-promo-plugin-locale'), __('PP Promo Tracking','paypal-promo-plugin-locale'), 'manage_options', 'pptrack', array($this,'pppcode_trackpage'));
		add_submenu_page(null, 'PayPal Promo Code', 'New PP PromoCode', 'manage_options', 'pppromo_popup', array($this,'pppcode_adminpage'));
		
		add_action('load-toplevel_page_pppromo-page', array($this,'paypal_button_add_help_tabs'));
		add_action('load-paypal-codes_page_ppaddset', array($this,'paypal_button_add_help_tabs'));
		add_action('load-paypal-codes_page_ppaddcode', array($this,'paypal_button_add_help_tabs'));
		add_action('load-paypal-codes_page_ppaddbutton', array($this,'paypal_button_add_help_tabs'));
		add_action('load-paypal-codes_page_pptrack', array($this,'paypal_button_add_help_tabs'));
		add_action('admin_enqueue_scripts',array($this,'register_admin_scripts'));	
	}
	
	public function register_admin_scripts($hook) {
		//all admin styles (i.e., menu icon. etc.)
		wp_enqueue_style( 'paypal-promo-plugin-admin-styles', $this->_PPPROMO_URLPATH .'css/pppcode-admin-styles.css' );
		global $wpdb;
		$temp = $wpdb->get_results("SELECT `pid`,`item_name` FROM `{$wpdb->prefix}pppromoproducts` ORDER BY `pid` ASC;");
		//print_r($temp);
		wp_localize_script('jquery','paypalPPButtons',array('buttons' => $temp));

		$pages = array(	'toplevel_page_pppromo-page','paypal-codes_page_ppaddbutton','paypal-codes_page_ppaddcode','paypal-codes_page_ppaddset','paypal-codes_page_pptrack');
		if( in_array( $hook, $pages ) ){
			//custom to the plugin only
			wp_enqueue_script( 'paypal-promo-plugin-admin-script', $this->_PPPROMO_URLPATH .'js/pppcode-admin.js' , array('jquery' /*,'jquery-ui-core' */ ) );
			wp_enqueue_script( 'paypal-promo-plugin-admin-script-select', $this->_PPPROMO_URLPATH .'js/jquery.asmselect.js', array( 'jquery', 'paypal-promo-plugin-admin-script' ) );
			wp_enqueue_style(  'paypal-promo-plugin-admin-styles-specific', $this->_PPPROMO_URLPATH .'css/pppcode-admin-specific-styles.css' );
		}
	}
	
	public function register_plugin_scripts() {
		//main styles & scripts
		wp_enqueue_script( 'pppsite_script', $this->_PPPROMO_URLPATH . 'js/pppcode-frontend.js', array('jquery'),'1.5.9');
		wp_enqueue_style( 'pppc-style-custom-main', $this->_PPPROMO_URLPATH.'css/pppcode-frontend-styles.css');
		$nonce = wp_create_nonce( 'pppcode_ajax_helper_654d6sghj' ) ;
		wp_localize_script('pppsite_script', 'pppcodeLocalize', array( 'ajaxURL' => admin_url('admin-ajax.php'), 'security' => $nonce));
		//override/additional styles
		$fileppcheck 			= get_stylesheet_directory().'/pppcode-styles.css';
		$fileppcheckcss 		= get_stylesheet_directory().'/css/pppcode-styles.css';
		$fileppcheckpppdir 		= $this->_PPPROMO_ABSPATH.'pppcode-styles-custom.css';
		$fileppcheckpppdircss 	= $this->_PPPROMO_ABSPATH.'css/pppcode-styles-custom.css';
		if( file_exists( $fileppcheck ) ){ //custom styles in template or child-template dir.
			wp_enqueue_style( 'pppc-style-custom-theme', get_bloginfo('template_directory').'/pppcode-styles.css');
		}elseif( file_exists( $fileppcheckcss ) ){ //custom styles in template or child-template css dir.
			wp_enqueue_style( 'pppc-style-custom-theme', get_bloginfo('template_directory').'/css/pppcode-styles.css');
		}else{
			if( file_exists( $fileppcheckpppdir ) ){ //allow for additional custom styles in the plugin dir
				wp_enqueue_style( 'pppc-style-custom-extra', $this->_PPPROMO_URLPATH.'pppcode-styles-custom.css');
			}elseif( file_exists( $fileppcheckpppdircss ) ){ //allow for additional custom styles in the plugin dir
				wp_enqueue_style( 'pppc-style-custom-extra', $this->_PPPROMO_URLPATH.'css/pppcode-styles-custom.css');
			}
		}
	}
	
	function render_shortcode_pppromo($atts) {
		if(array_key_exists('0',$atts)){
			$pppromo = str_replace('=','',$atts[0]);
		}else{
			extract(shortcode_atts(array('id' => '0', 'button'=> '', 'align' => '', 'hide_title' => '0'), $atts));
			$attsNew = shortcode_atts(array('id' => '0', 'button'=> '', 'align' => '', 'hide_title' => '0'), $atts);
			$pppromo = $id;
		}
		return $this->make_pppform($pppromo, $attsNew);
	}
	
	function register_plugin_action() {
		/* NOTE:  WordPress Actions: http://codex.wordpress.org/Plugin_API#Actions | Action Reference:  http://codex.wordpress.org/Plugin_API/Action_Reference */
	}
	
	function register_plugin_filter() {
		/* NOTE:  WordPress Filters: http://codex.wordpress.org/Plugin_API#Filters | Filter Reference:  http://codex.wordpress.org/Plugin_API/Filter_Reference */
	}
	
	public function ppp_queryhook($vars) {
		$vars[] = 'custom';
		if(is_admin())
			$vars[] = 'mode';
		return $vars;
	}
		
	public function ppp_parse_request() {
		//Hook into the Query Parse and get our vars to see if the page is the one we want.
		global $wp;
		if(isset($_POST['txn_id']) && isset($_POST['ipn_type']) && isset($_POST['custom']) && strpos($_POST['custom'],'X235YWaa')!== false ){
			include('paypalpromoreturn.php');
			exit;
		}
	}
	
	function ppp_upgrade($checkfor='') {
		global $wpdb;
		$pppromo			= $wpdb->prefix . 'pppromo';
		$pppromoproducts	= $wpdb->prefix . 'pppromoproducts';
		$theupgradedone		= '0';
		if($wpdb->get_var("show tables like '$pppromo'") == $pppromo) {	// Be sure that the tables exist
			$installed_ver = get_option( "ppp_db_version" );
			if($installed_ver==''){
				$installed_ver='0';
			}else{
				$installed_ver_int = (int)str_replace('.','',$installed_ver);
			}
			if($installed_ver_int<=148 && $installed_ver_int>0){
				 $result = $wpdb->query("ALTER TABLE " . $pppromoproducts . " CHANGE `button_type` `button_type` INT( 5 ) NULL DEFAULT '1'") ;
				 if($result){
				 	$theupgradedone='1';
				 }
				 update_option("ppp_db_complete", (int)str_replace('.','',$checkfor));
				 update_option("ppp_db_version", $this->_PPP_DBVERSION);
			}
		}
		return $theupgradedone;
	}
	
	function make_pppform($pppnumber, $attsNew= array()){
		// MAKE PayPal Button Form - MAIN BUTTON FUNCTION
		if($pppnumber == '')
			return;
		global $wpdb, $post;
		$newpppform			= '';
		$table_name 		= $wpdb->prefix . "pppromo";
		$table_name2		= $wpdb->prefix . "pppromoproducts";
		$this->buttontype	= apply_filters('pppcode-button-type',"_xclick"); //button
	    $align 				= apply_filters('pppcode-align-promo-box',isset($attsNew['align']) && $attsNew['align'] != '' ? sanitize_text_field($attsNew['align']) : '');
	    $hideBTitle			= apply_filters('pppcode-hide-button-title',isset($attsNew['hide_title']) && (bool) $attsNew['hide_title'] === true ? true : false);

		//Get Button Items
		$pplist 		= $wpdb->get_row("SELECT * FROM $table_name2 WHERE pid='".$pppnumber."'");
		if( !$pplist )
			return;
		
		$item_name		= $pplist->item_name;
		$item_num		= $pplist->item_num;
		$special_instr	= (int) $pplist->special_instr;
		$amount			= str_replace('','',$pplist->amount);
		$shipping		= $pplist->shipping;
		$shippingamount	= $pplist->shipping_amt;
		$return_url		= $pplist->return_url;
		$cancel_url		= $pplist->cancel_url;
		if($return_url==''){$return_url=get_bloginfo('url');}
		if($cancel_url==''){$cancel_url=get_bloginfo('url');}
		$currency_code	= $pplist->currency_code != '' ? $pplist->currency_code : getMultiOption('ppp_options','currencyCode');
		$button_type	= $pplist->button_type;
		$pp_emailadd	= $pplist->pp_emailadd;
		$buttonUrl		= $this->getPPButtonUrl($button_type);
		$buttonUrlshort	= $this->getPPButtonUrlshort($button_type);
		if($button_type === '128'){$this->buttontype = '_cart';}
		if($button_type === '300'){$this->buttontype = '_donations';}
		$origamt		= $amount;
		$pcodemsg		= '';
		$curSym			= $this->curSym;
		$pcode			= $this->procodesession != '' ? $this->procodesession : '';
		$getppbutton 	= $wpdb->get_row("SELECT * FROM {$table_name} WHERE (`sdate` <= CURDATE() and `edate` >= CURDATE() ) and (`description` like'%s:1:\"0\";%' or `description` like '%s:%:\"{$pppnumber}\";%') ");
		
		//check if Procode is assigned to this perticular button 
		$getppid3		= false;
		if($pcode != '')
			$getppid3 		= $wpdb->get_row("SELECT `ppid`,`ppdiscount`,`ppdiscounttype`,`sdate`,`edate`,`description` FROM {$table_name} WHERE `ppname` = '{$pcode}'");
		if($getppid3){
			if($getppid3->sdate > date('Y-m-d')){$pcodemsg.= __('Starts: ','paypal-promo-plugin-locale').date_format(date_create($getppid3->sdate),'m\/d\/Y');}
			if($getppid3->edate < date('Y-m-d')){$pcodemsg.= __('Expired:','paypal-promo-plugin-locale').date_format(date_create($getppid3->edate),'m\/d\/Y');}
			if($getppid3->sdate <=date('Y-m-d')&& $getppid3->edate>=date('Y-m-d')){
				if(in_array($pppnumber,unserialize($getppid3->description))){
					$workingnum=$getppid3->ppdiscount;
					if($getppid3->ppdiscounttype==1){ 
						$newamount = round( $amount - ( $workingnum * $amount ) / 100, 2 ); /* this is Percent Off*/
						$pcodemsg.= '<span style="color:#FF0000;">'.$pcode.' - '.$workingnum.'% '.__('Off Regular Price','paypal-promo-plugin-locale').'</span>';
						$amount	= $newamount;
					}elseif($getppid3->ppdiscounttype==2){ 
						if($amount>=$workingnum){
							$newamount=$amount-$workingnum; //$Off
							$pcodemsg.= '<span style="color:#FF0000;">'.$pcode.' - '.apply_filters('paypal-promo-price-symbol','$',$currency_code).$workingnum.' '.__('Off Regular Price','paypal-promo-plugin-locale').'</span>';
							$amount=$newamount;
						}else{
							$newamount=$amount;
							$pcodemsg.= '<span style="color:#FF0000;">'.$pcode.' - '.apply_filters('paypal-promo-price-symbol','$',$currency_code).$workingnum.' '.__('Off Regular Price','paypal-promo-plugin-locale').'</span>';
							$amount=$newamount;
						}
					}elseif($getppid3->ppdiscounttype==3){ 
							$newamount=$workingnum; //$set price 
							$pcodemsg.= '<span style="color:#FF0000;">'.$pcode.' - '.__('Item for only ','paypal-promo-plugin-locale').apply_filters('paypal-promo-price-symbol','$',$currency_code).$newamount.' ('.__('normally ','paypal-promo-plugin-locale').$curSym[$currency_code].$amount.' - '.__('a savings of ','paypal-promo-plugin-locale').$curSym[$currency_code].($amount-$newamount).')</span>';
							$amount	=$newamount;
					}
				}else{	
					$pcodemsg =__('Current PromoCode does not apply to this item.','paypal-promo-plugin-locale');
				}
			}
		}else{
			if($pcode != ''){
				$pcodemsg = __('Not a valid PromoCode.','paypal-promo-plugin-locale');
				$this->procodesession = "";
				setcookie("procode", $value,  time() - (86400 * 30), "/");
			}
		}
		
		$newpppform[] = '
		<div class="pppromo-container-wrapper">
			<a name="ppbtn'.$pppnumber.'"></a>
			<div class="pppromo-container ppp-container-'.$pppnumber.'">';
			
		//Get Post Meta
		$extrameta 	= '';
		$image 		= '';
		$buttonmeta = get_post_meta($post->ID,'pppromo-meta-'.$pppnumber,false);
		if( count($buttonmeta) > 0 ){
			if( is_array( $buttonmeta ) ){
				foreach($buttonmeta as $buttonmetas){
					$splitmeta = explode('::',$buttonmetas);
					if($splitmeta[0]!='' && $splitmeta[1]!='' && strtolower($splitmeta[0]) == 'image'){
						$extrsclass = $splitmeta[2] != '' ? ' '.$splitmeta[2]  : '';
						$image.= '<img src="'.$splitmeta[1].'" class="paypal-promo-meta-image'.$pppnumber.$extrsclass.'" />';
					}else{
						if($splitmeta[0]!=''){
							$extrameta .='<br /><strong>'.$splitmeta[0].': </strong>';
						}
						if($splitmeta[1]!=''){
							$extrameta .='<span class="ppp-highlight">'.$splitmeta[1].'</span>';
						}
					}
				}
			}else{
				$splitmeta = explode('::',$buttonmeta);
				if($splitmeta[0]!='' && $splitmeta[1]!='' && strtolower($splitmeta[0]) == 'image'){
					$extrsclass = $splitmeta[2] != '' ? ' '.$splitmeta[2]  : '';
					$extrameta .='<img src="'.$splitmeta[1].'" class="paypal-promo-meta-image'.$pppnumber.$extrsclass.'" />';
				}else{
					if($splitmeta[0]!=''){
						$extrameta .='<br /><strong>'.$splitmeta[0].': </strong>';
					}
					if($splitmeta[1]!=''){
						$extrameta .='<span class="ppp-highlight">'.$splitmeta[1].'</span><br />';
					}
				}
			}
		}
		
		if( $shippingamount != '0' )
				$shippingxtra ='<br /><span class="pppshipping"><strong>'.__('Shipping:','paypal-promo-plugin-locale').'</strong><span class="ppp-highlight">&nbsp;'.apply_filters('paypal-promo-price-symbol',__('$','paypal-promo-plugin-locale'),$currency_code).$shippingamount.'</span></span>';

		//check if the new amount is less than the original amount. if yes, then display message
		if(!$hideBTitle)
			$newpppform[] = '<strong><span class="button-title">'.$item_name .'</span></strong>';
		if ($getppbutton && $amount < $origamt){
			$newpppform[] = '<div class="pppromo-container-message">'.$image.'<span class="ppppricing pppdiscount"><span class="pppromo-price-label">'.__('Price:','paypal-promo-plugin-locale').' </span><span class="pppromo-price-strike">'.apply_filters('paypal-promo-price-symbol',__('$','paypal-promo-plugin-locale'),$currency_code).$origamt.'</span><span class="pppromo-price-sale">&nbsp;'.__('Discounted Price: ','paypal-promo-plugin-locale').apply_filters('paypal-promo-price-symbol',__('$','paypal-promo-plugin-locale'),$currency_code).number_format($amount, 2, '.', '').'</span><span class="pppromo-shipping-meta">'.$shippingxtra.'</span><div class="pppromo-extra-meta">'.$extrameta.'</div></div>';
		}elseif($getppbutton){
			$newpppform[] = '<div  class="pppromo-container-message">'.$image.'<span class="ppppricing"><span class="pppromo-price-label">'.__('Price:','paypal-promo-plugin-locale').' </span><span class="pppromo-price-strike"></span><span class="pppromo-price-sale">'.apply_filters('paypal-promo-price-symbol',__('$','paypal-promo-plugin-locale'),$currency_code).$origamt.'</span><span class="pppromo-shipping-meta">'.$shippingxtra.'</span><div class="pppromo-extra-meta">'.$extrameta.'</div></div>';
		}else{
			$newpppform[] = '<div class="pppromo-container-message">'.$image.'<span class="ppppricing"><span class="pppromo-price-label">'.__('Price:','paypal-promo-plugin-locale').' </span><span class="pppromo-price-strike"></span><span class="pppromo-price-sale">'.apply_filters('paypal-promo-price-symbol',__('$','paypal-promo-plugin-locale'),$currency_code).$amount.'</span><span class="pppromo-shipping-meta">'.$shippingxtra.'</span><div class="pppromo-extra-meta">'.$extrameta.'</div></div>';

		}
		
		if( $getppbutton && ( $pcode == "" || $pcodemsg == __('Current PromoCode does not apply to this item.','paypal-promo-plugin-locale' ) ) ){
			$pcodemsg  	= $pcodemsg != '' ?  $pcodemsg.'<br />' : '' ;
			$newpppform[] = '
			<form method="post" name="pp_promocodeFRM'.$pppnumber.'" action="'.selfURL().'#ppbtn'.$pppnumber.'" class="pppcode-show">
				<span class="ppcode-msg">'.$pcodemsg.'</span>'.__(' Promo Code <i>(optional)</i>','paypal-promo-plugin-locale').'<br/>
				<input type="text" name="pp_promocode" class="pp_promocode_'.$pppnumber.'" size="22" value="" />
				<input type="hidden" name="pp_promocode_num" value="'.$pppnumber.'" />
				<input type="submit" value="apply" name="pp_promoapply" class="pp_promoapply" data-promocode-id="'.$pppnumber.'" data-promocode-field="pp_promocode_'.$pppnumber.'"/>
			</form>
			<form method="post" name="pp_promocodeFRMclear" action="'.selfURL().'#ppbtn'.$pppnumber.'" class="pppcode-hide">
				'.__('Promo Code Applied: ','paypal-promo-plugin-locale').'
				<div class="ppp-ajax-message-button-'.$pppnumber.'">'.$pcodemsg.'</div>
				<input type="hidden" name="pp_promocode_num" value="'.$pppnumber.'" />
				<input type="submit" value="clear promo code" name="pp_promoclear" class="pp_promoclear" data-promocode-id="'.$pppnumber.'" />
			</form>
			';
		}elseif($getppbutton){
			$pcodemsg 	=  $pcodemsg != '' ? '<br />'.$pcodemsg.'<br />' : '' ;
			$newpppform[] = '
			<form method="post" name="pp_promocodeFRM'.$pppnumber.'" action="'.selfURL().'#ppbtn'.$pppnumber.'" class="pppcode-hide">
				<span class="ppcode-msg">'.$pcodemsg.'</span>'.__(' Promo Code <i>(optional)</i>','paypal-promo-plugin-locale').'<br/>
				<input type="text" name="pp_promocode" class="pp_promocode_'.$pppnumber.'" size="22" value="" />
				<input type="hidden" name="pp_promocode_num" value="'.$pppnumber.'" />
				<input type="submit" value="apply" name="pp_promoapply" class="pp_promoapply" data-promocode-id="'.$pppnumber.'" data-promocode-field="pp_promocode_'.$pppnumber.'"/>
			</form>
			<form method="post" name="pp_promocodeFRMclear" action="'.selfURL().'#ppbtn'.$pppnumber.'" class="pppcode-show">
				'.__('Promo Code Applied: ','paypal-promo-plugin-locale').'
				<div class="ppp-ajax-message-button-'.$pppnumber.'">'.$pcodemsg.'</div>
				<input type="hidden" name="pp_promocode_num" value="'.$pppnumber.'" />
				<input type="submit" value="clear promo code" name="pp_promoclear" class="pp_promoclear" data-promocode-id="'.$pppnumber.'" />
			</form>';
		}
		
		$formurl 	= (int) getMultiOption('ppp_options','') == 1 ? 'https://www.sandbox.paypal.com/cgi-bin/webscr' : 'https://www.paypal.com/cgi-bin/webscr';
	  	$newpppform[] = '<form action="'.$formurl.'" method="post" style="margin-top:5px;"><input type="hidden" name="cmd" value="'.$this->buttontype.'" /><input type="hidden" name="business" value="'.$pp_emailadd.'" /><input type="hidden" name="item_name" value="'.$item_name.'" /><input type="hidden" name="item_number" value="'.$item_num.'" />';
		
		// Allow Special Instruction Option
		if( $special_instr == 1 )
			$newpppform[] = '<input type="hidden" name="cn" value="'.__('Add special instructions here','paypal-promo-plugin-locale').'" />';
		
		// Shipping Required Option
		$newpppform[] = '<input type="hidden" name="no_shipping" value="'.( $shipping == 1 ? 0 : 1 ).'" />';
		
		if($this->buttontype == '_cart' || $button_type=='128')
			$newpppform[] = '<input type="hidden" name="add" value="1" /> ';
			
		if( $pcode == '' && $this->procodesession != '')
			$this->procodesession = '';
			
		$newpppform[] = '<input type="hidden" name="rm" value="1" /><input type="hidden" name="amount" value="'.$amount.'" data-reg-amt="'.$origamt.'" data-curr-symbol="'.apply_filters('paypal-promo-price-symbol','$',$currency_code).'"/><input type="hidden" name="undefined_quantity" size="20" value="1" /><input type="hidden" name="return" value="'.$return_url.'" /><input type="hidden" name="cancel_return" value="'.$cancel_url.'" /><input type="hidden" name="currency_code" value="'.$currency_code.'" /><!--input type="hidden" name="weight_unit" value="lbs" /--><input type="hidden" name="tax_rate" value="0" /><input type="hidden" name="bn" value="PP-BuyNowBF:'.$buttonUrlshort.':NonHosted" /><input type="hidden" name="notify_url" value="'.get_bloginfo('url').'/index.php" /><input type="hidden" name="custom" value="'.$pcode.'|'.$return_url.'|'.$pppnumber.'|X235YWaa" />';
		$newpppform[] = '<input type="hidden" name="shipping" value="'.$shippingamount.'" />';
		$newpppform[] = '<input type="image" src="'.$buttonUrl.'" style="border:0 none;margin-bottom:5px;" name="submit" alt="" /></form></div></div>';
		
		return implode("\n",$newpppform);
	}
	
	function getPPButtons($btn){
		// PayPal Buttons loop
		$have_buttons = array(99,98,5,6,9,11,12,22,23,24,97);
		//$have_buttons = array(98,99,300,128,127);
		$buttnTxt='';
		if ($btn==1){$btn=99;}
		$btns = 0;
		foreach ($have_buttons as $x) {	
			$btns = $btns +1;
			if ($x == $btn){$bchecked=' checked="checked"';}else{$bchecked='';}
			if($x == 99){
				 $url = $this->_PPPROMO_URLPATH."images/paymentButton-pay.gif";
				 $buttnTxt.= '<div class="button-select-div"><input type="radio" name="pppcodebtn_button" id="pppcodebtn_button'.$btns.'"'.$bchecked.' value="'.$x.'"/><img src="'.$url.'" alt="" align="top"/></div>'."\n";
			}elseif($x == 98){
				 $url = $this->_PPPROMO_URLPATH."images/paymentButton-buy.gif";
				 $buttnTxt.= '<div class="button-select-div"><input type="radio" name="pppcodebtn_button" id="pppcodebtn_button'.$btns.'"'.$bchecked.' value="'.$x.'"/><img src="'.$url.'" alt="" align="top"/></div>'."\n";
			}elseif($x == 97){
				 $url = $this->_PPPROMO_URLPATH."images/paymentButton-subscribe.gif";
				 $buttnTxt.=  '<div class="button-select-div"><input type="radio" name="pppcodebtn_button" id="pppcodebtn_button'.$btns.'"'.$bchecked.' value="'.$x.'"/><img src="'.$url.'" alt="" align="top"/></div>'."\n";
			}elseif($x == 127){
				 $url = $this->_PPPROMO_URLPATH."images/paymentButton2.gif";
				 $buttnTxt.=  '<div class="button-select-div"><input type="radio" name="pppcodebtn_button" id="pppcodebtn_button'.$btns.'"'.$bchecked.' value="'.$x.'"/><img src="'.$url.'" alt="" align="top"/></div>'."\n";
			}elseif($x == 128){
				 $url = $this->_PPPROMO_URLPATH."images/paymentButton-cart.gif";
				 $buttnTxt.=  '<div class="button-select-div"><input type="radio" name="pppcodebtn_button" id="pppcodebtn_button'.$btns.'"'.$bchecked.' value="'.$x.'"/><img src="'.$url.'" alt="" align="top"/></div>'."\n";
			}elseif($x == 300){
				 $url = $this->_PPPROMO_URLPATH."images/paymentButton-donate.gif";
				 $buttnTxt.=  '<div class="button-select-div"><input type="radio" name="pppcodebtn_button" id="pppcodebtn_button'.$btns.'"'.$bchecked.' value="'.$x.'"/><img src="'.$url.'" alt="" align="top"/></div>'."\n";
			}else{
				$url = "http://www.paypal.com/en_US/i/btn/x-click-but$x.gif";
				$buttnTxt.=  '<div class="button-select-div"><input type="radio" name="pppcodebtn_button" id="pppcodebtn_button'.$btns.'"'.$bchecked.' value="'.$x.'"/><img src="'.$url.'" alt="" align="top"/></div>'."\n";
			}
			//if($btns==2){$btns=0;$buttnTxt.=  '<div style="clear:both;"></div>';}
		}
		return $buttnTxt;
	}
	
	function getPPButtonUrl($btn){
	// URL for the button
		if($btn==1 || $btn==''){$btn=99;}
		if($btn==99){
			 $url = $this->_PPPROMO_URLPATH."images/paymentButton-pay.gif";
		}elseif($btn==98){
			 $url = $this->_PPPROMO_URLPATH."images/paymentButton-buy.gif";
		}elseif($btn==97){
			 $url = $this->_PPPROMO_URLPATH."images/paymentButton-subscribe.gif";
		}elseif($btn==127){
			 $url = $this->_PPPROMO_URLPATH."images/paymentButton2.gif";
		}elseif($btn==128){
			 $url = $this->_PPPROMO_URLPATH."images/paymentButton-cart.gif";
		}elseif($btn==129){
			 $url = $this->_PPPROMO_URLPATH."images/paymentButton-viewcart.gif";
		}elseif($btn==300){
			 $url = $this->_PPPROMO_URLPATH."images/paymentButton-donate.gif";
		}else{
			  $url = "https://www.paypal.com/en_US/i/btn/x-click-but$btn.gif";
		}
		return apply_filters('pppcode-button-url',$url);
	}
	
	function getPPButtonUrlshort($btn){
	// short URL for the button
		if($btn==1 || $btn==''){$btn=99;}
		if($btn==99){
			 $url = "btn_paynowCC_LG.gif";
		}elseif($btn==98){
			 $url = "btn_buynowCC_LG.gif";
		}elseif($btn==97){
			 $url = "btn_subscribeCC_LG.gif";
		}elseif($btn==127){
			 $url = "paymentButton.gif";
		}elseif($btn==128){
			 $url = "paymentButton-cart.gif";
		}elseif($btn==129){
			 $url = "paymentButton-viewcart.gif";
		}elseif($btn==300){
			 $url = "paymentButton-donate.gif";
		}else{
			 $url = "x-click-but$btn.gif";
		}
		return apply_filters('pppcode-button-url-short',$url);
	}
	
	function render_shortcode_pppromocart($atts) {
	     return $this->make_pppviewcart($atts);
	}
	
	function make_pppviewcart($atts){
	//MAKE View Cart Button
		global $wpdb, $post;
		$pp_emailadd = getMultiOption('ppp_options','emailid');
		if($pp_emailadd!=''){
			$buttonUrlshort 	= $this->getPPButtonUrlshort(129);
			$buttonUrl 			= $this->getPPButtonUrl(129);
			$newpppform 		= '
			<form target="paypal" action="https://www.paypal.com/cgi-bin/webscr" method="post">
				<input type="hidden" name="cmd" value="_cart" />
				<input type="hidden" name="business" value="'.$pp_emailadd.'" />
				<input type="hidden" name="bn" value="PP-BuyNowBF:'.$buttonUrlshort.':NonHosted" />
				<input type="image" src="'.$buttonUrl.'" style="border:0 none;margin-bottom:5px;" name="submit" alt="" />
				<img class="ppp-1pix" alt="" border="0" src="https://www.paypal.com/fr_FR/i/scr/pixel.gif" width="1" height="1" style="border:0 none;background:none;padding:0;" />
				<input type="hidden" name="display" value="1" />
			</form>
			';
			return apply_filters( 'make_pppviewcart', $newpppform, $buttonUrlshort, $buttonUrl, $pp_emailadd );
		}else{
			return apply_filters( 'make_pppviewcart', '', '', '', '' );
		}
	}
		
	function ppp_default_options() {
	// default WordPress options during setup
		global $blog_id;
		$ppp_options['currencyCode']	= "USD";  						// PayPal Currency Code 
		$ppp_options['returnUrl']		= get_bloginfo('url');						
		$ppp_options['cancelUrl']		= get_bloginfo('url');						
		$ppp_options['shipping']		= false; 						//Include Shipping							
		$ppp_options['special']			= true;							//Include Special Instructions						
		$ppp_options['emailid']			= '';							//
		return do_action('ppp_default_options',$ppp_options);
	}
    
	function pppromoadminmain () { 
	//main admin page
		$screen = get_current_screen();
		require_once(dirname(__FILE__).'/includes/class-wp-paypalbuttons-list-table.php');
		require_once(dirname(__FILE__).'/includes/class-wp-paypalpromocodes-list-table.php');
		$wp_list_ppbuttons = new WP_PayPalButtons_List_Table(array('screen' => $screen)); 
		$wp_list_pppromos  = new WP_PayPalPromos_List_Table(array('screen' => $screen)); 
		$wp_list_ppbuttons->prepare_items();
		$wp_list_pppromos->prepare_items();
		$query = $_REQUEST;
			echo '<div class="wrap">';
			echo '<h2>'.'PayPal Promocode - '.$this->_PPPVERSION;
			if ( !empty($_REQUEST['s']) ){
				printf( '<span class="subtitle">' . __('Search results for &#8220;%s&#8221;' ,'paypal-promo-plugin-locale') . '</span>', esc_html( stripslashes($_REQUEST['s']) ) ); 
			}
			echo '</h2>';
			$mode 	=  isset($query['mode']) && $query['mode'] != '' ? esc_attr($query['mode']) : '';
			if( $mode != '' ){
				if ( $mode == 'pppcode_rem_msg') {
					?><div id="message" class="updated fade"><p><strong><?php _e('PayPal PromoCode Deleted', 'paypal-promo-plugin-locale'); ?>.</strong></p></div><?php		
				}elseif ( $mode == 'pppcodebtn_rem_msg' ) {
					?><div id="message" class="updated fade"><p><strong><?php _e('PayPal Button Deleted', 'paypal-promo-plugin-locale'); ?>.</strong></p></div><?php
				}elseif ($mode == 'pppcode_edit_msg' ) {
					?><div id="message" class="updated fade"><p><strong><?php _e('PayPal Promo Code Updated', 'paypal-promo-plugin-locale'); ?>.</strong></p></div><?php
				}elseif ( $mode == 'pppcodebtn_edit_msg' ) {
					?><div id="message" class="updated fade"><p><strong><?php _e('PayPal Button Updated', 'paypal-promo-plugin-locale'); ?>.</strong></p></div><?php
				}elseif ( $mode == 'pppcode_new_msg') {
					?><div id="message" class="updated fade"><p><strong><?php _e('PayPal Promo Code Added', 'paypal-promo-plugin-locale'); ?>.</strong></p></div><?php
				}elseif ( $mode == 'pppcodebtn_new_msg' ) {
					?><div id="message" class="updated fade"><p><strong><?php _e('PayPal Button Added', 'paypal-promo-plugin-locale'); ?>.</strong></p></div><?php
				}
			}
			echo '<p>'.__('The PayPal PromoCode plugin allows you to create custom PromoCodes for your PayPal Buttons. The buttons must be created using the NEW BUTTON option from this plugin in order for PromoCodes to work with them.','paypal-promo-plugin-locale' ).'</p><p>';
			echo '<p>'.__('This plugin is NOT intended for sites that already have PayPal buttons and are only looking to add promocode functionality, as the promocodes will not be integrated into the buttons and no discounts will be applied. Currently, hosted PayPal buttons will not work. PromoCodes are not case sensitive.','paypal-promo-plugin-locale' ).'</p>';
			echo '<hr/>';
			?>
			<form id="promocodes-filter" action="" method="post" style="margin-top:35px;margin-bottom:35px;">
           		<h2 style="float:left;margin:0;"><?php echo __('Current PayPal PromoCodes',  'paypal-promo-plugin-locale');?>&nbsp;&nbsp;<a href="<?php echo admin_url('admin.php?page=ppaddcode');?>" class="add-new-h2"><?php echo __('Add New PayPal Promocode',  'paypal-promo-plugin-locale');?></a></h2>
				<?php $wp_list_pppromos->search_box( __( 'Search Buttons' ), 'paypal-promo-plugin-locale' ); ?>
				<?php $wp_list_pppromos->display(); ?>
				<div id="ajax-response"></div>
			</form>
            <hr/>
			<form id="buttons-filter" action="" method="post" style="margin-top:35px;">
           		 <h2 style="float:left;margin:0;"><?php echo __('Current PayPal Buttons',  'paypal-promo-plugin-locale');?>&nbsp;&nbsp;<a href="<?php echo admin_url('admin.php?page=ppaddbutton');?>" class="add-new-h2"><?php echo __('Add New PayPal Button',  'paypal-promo-plugin-locale');?></a></h2>
				<?php $wp_list_ppbuttons->search_box( __( 'Search Buttons' ), 'paypal-promo-plugin-locale' ); ?>
				<?php $wp_list_ppbuttons->display(); ?>
				<div id="ajax-response"></div>
			</form>
			<?php
			echo '</div>';
	}
	
	function pppcode_setpage() {
	/* admin page Settings */
		$screen = get_current_screen();
		global $wpdb;
		echo '<div class="wrap">';
		echo '<h2>'.__('PayPal Promocode Settings', 'paypal-promo-plugin-locale').'</h2>';
		echo __('You can add default settings to your button creation. Use the HELP button in the top right of the screen for additional infomation.','paypal-promo-plugin-locale').'<br /><hr noshade color="#C0C0C0" size="1" />';
		echo '<h2>'.__('Default Options', 'paypal-promo-plugin-locale').'</h2>';
			$this->pppcode_setform();
		echo '</div>';
	}
	
	function pppcode_setform(){
	//Options Page for Admin
		global $wpdb;
			if ( isset( $_REQUEST['pppcode_set'] ) ) {
				$this->pppcode_updatesettings();
				?><div id="message" class="updated fade"><p><strong><?php _e('PayPal PromoCode Settings Updated', 'paypal-promo-plugin-locale'); ?>.</strong></p></div><?php
			}
		echo '
			<form name="pppsetcode" action="?page=ppaddset" method="post" id="pppsetcode" onsubmit="return checkSetForm(this);"> 
			<table class="form-table">
			  <tbody>
				<tr>
					<th scope="row"><label for="pppc_email">'.__('PayPal Email Address or Secure Merchant Account ID:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input id="pppc_email" name="pppc_email" type="text" value="'.getMultiOption('ppp_options','emailid').'" size="42"></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppc_currencyCode">'.__('Currency Code:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input id="pppc_currencyCode" name="pppc_currencyCode" type="text" value="'.getMultiOption('ppp_options','currencyCode').'" size="8"> <span style="font-size:10px;">'.__('for example, <code>USD</code> or <code>AUD</code>, etc.').'</span></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppc_returnUrl">'.__('Return URL<br/>(after successful purchase):', 'paypal-promo-plugin-locale').'</label></th>
					<td><input id="pppc_returnUrl" name="pppc_returnUrl" type="text" value="'.getMultiOption('ppp_options','returnUrl',get_bloginfo('url').'/').'" size="46"></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppc_cancelUrl">'.__('Cancel URL<br/>(before purchase):', 'paypal-promo-plugin-locale').'</label></th>
					<td><input id="pppc_cancelUrl" name="pppc_cancelUrl" type="text" value="'.getMultiOption('ppp_options','cancelUrl',get_bloginfo('url').'/').'" size="46"></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppc_shipping">'.__('Require Shipping?:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input '.checkifchecked(1,(int)getMultiOption('ppp_options','shipping')).' id="pppc_shipping" name="pppc_shipping" type="checkbox" value="1"></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppc_special">'.__('Allow SPECIAL MESSAGE Box for Customer:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input '.checkifchecked(1,(int)getMultiOption('ppp_options','special')).' id="pppc_special" name="pppc_special" type="checkbox" value="1"></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppc_">'.__('Test Mode Only<br/>(PayPal ):', 'paypal-promo-plugin-locale').'</label></th>
					<td><input '.checkifchecked(1,(int)getMultiOption('ppp_options','')).' id="pppc_" name="pppc_" type="checkbox" value="1">  <span style="font-size:10px;">*'.__('(You will need a <a target="_blank" href="https://www..paypal.com/">PayPal </a> testing account. )', 'paypal-promo-plugin-locale').'</span></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppc_nonotice">'.__('Don\'t Send IPN Notices:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input '.checkifchecked(1,(int)getMultiOption('ppp_options','nonotice')).' id="pppc_nonotice" name="pppc_nonotice" type="checkbox" value="1">  <span style="font-size:10px;"> '.__('(PayPal will still send you PayPal notices, but this plugin will not send IPN notices)', 'paypal-promo-plugin-locale').'</span></td>
				</tr>
			  </tbody>
			</table>
			<p class="submit"><input type="submit" name="pppcode_set" value="'.__('Update Options', 'paypal-promo-plugin-locale').'" class="button button-primary"  /> <input type="button" value="'.__('Cancel', 'paypal-promo-plugin-locale').'" name="pppcodebtn_cancel" id="pppcodebtn_cancel" class="button button-secondary" onclick="history.back();"></p>
			</form>	
		';
	}
	
	function pppcode_updatesettings(){
	/* update PayPal PromoCode in Options */
		global $wpdb,$blog_id;
		$ppp_options 						= $this->ppp_options;
		$pppc_email 						= isset($_POST['pppc_email']) && is_email($_POST['pppc_email']) ? sanitize_email($_POST['pppc_email']) : '';
		$pppc_currencyCode 					= isset($_POST['pppc_currencyCode']) && $_POST['pppc_currencyCode'] != '' ? esc_attr($_POST['pppc_currencyCode']) : 'USD';
		$pppc_returnUrl 					= isset($_POST['pppc_returnUrl']) && $_POST['pppc_returnUrl'] != '' ? esc_url_raw($_POST['pppc_returnUrl']) : '';
		$pppc_cancelUrl 					= isset($_POST['pppc_cancelUrl']) && $_POST['pppc_cancelUrl'] != '' ? esc_url_raw($_POST['pppc_cancelUrl']) : '';
		$pppc_shipping 						= isset($_POST['pppc_shipping']) && (int) $_POST['pppc_shipping'] == 1 ? 1 : 0;
		$pppc_special 						= isset($_POST['pppc_special']) && (int) $_POST['pppc_special'] == 1 ? 1 : 0;
		$pppc_ 						= isset($_POST['pppc_']) && (int) $_POST['pppc_'] == 1 ? 1 : 0;
		$pppc_nonotice 						= isset($_POST['pppc_nonotice']) && (int) $_POST['pppc_nonotice'] == 1 ? 1 : 0;
		$ppp_options['currencyCode']		= $pppc_currencyCode;  					// PayPal Currency Code 
		$ppp_options['returnUrl']			= $pppc_returnUrl;						// PayPal Return URL
		$ppp_options['cancelUrl']			= $pppc_cancelUrl;						// PayPal Cancel URL
		$ppp_options['shipping']			= $pppc_shipping; 						// Include Shipping							
		$ppp_options['special']				= $pppc_special;						// Include Special Instructions						
		$ppp_options['']				= $pppc_;						//  Testing					
		$ppp_options['nonotice']			= $pppc_nonotice;						// Don't send IPN Notices				
		$ppp_options['emailid']				= $pppc_email;							// PayPal Email or Secure ID
		$this->ppp_options 					= apply_filters('pppcode_updatesettings',$ppp_options);
		update_option('ppp_options', $this->ppp_options);
	}
	
	function pppcode_adminpage() {
	/* admin page display */
		global $wpdb;
		$noshowform	= false;
		echo '<div class="wrap">';
			if (isset($_REQUEST['mode']) && $_REQUEST['mode']=='pppcodeedit' && isset($_REQUEST['ppid'])) {
				$this->pppcode_edit($_REQUEST['ppid']);
				$noshowform = true;
			}
		echo '</div>';
		/* show form to add new PayPal PromoCode */
		if(!$noshowform)
			echo '<div class="wrap">'.$this->pppcode_newform(false).'</div>';
		
	}
	function pppcode_trackpage() {
	/* Track page display */
		global $wpdb;
		echo '<div class="wrap">';
		echo '<h2>'.'PayPal Promocode Tracking</h2>';
		echo '<div><br/><br/>This function is not yet available.</div>';
		echo '</div>';
	}
	
	function pppcode_newform($echo = true) {
	/* Admin  - add new PayPal PromoCode form  */
	global $wpdb;
		$addnewpppcode='';
		$table_name = $wpdb->prefix . "pppromoproducts";
		$addnewpppcode .= '<h2>'.__('Add New PayPal PromoCode', 'paypal-promo-plugin-locale').'</h2>';
		$addnewpppcode .= '<p>'.__('Add New Promo Code Below. See Help in top right of screen for information on each field.', 'paypal-promo-plugin-locale').'</p>';
		$addnewpppcode .= '<hr/>';
		$pppButtons = $wpdb->get_results('SELECT * FROM '.$table_name.' order by pid DESC');
		$button_options = array();
		foreach ($pppButtons as $button_row){
			$button_options[] = "\t\t\t\t\t\t\t".'<option value="'.$button_row->pid.'">'.$button_row->item_name.' ( $'.$button_row->amount.' )</option>"';
		}
		$nobuttons = (empty($button_options)) ? true : false;
		$addnewpppcode .= '
			<form name="pppaddcode" action="?page=ppaddcode&mode=pppcode_addnew" method="post" id="pppaddcode">
			<table class="form-table">
			  <tbody>
				<tr>
					<th scope="row"><label for="pppromocode_name">'.__('Enter a Code:', 'paypal-promo-plugin-locale').'<br/><span style="font-size:12px;font-style:italic;">'.__( '(name, number or combination)', 'paypal-promo-plugin-locale' ).'</span></label></th>
					<td><input id="pppromocode_name" name="pppromocode_name" type="text" placeholder="i.e., tenoff" value="" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppromocode_start">'.__('Promo Start Date:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input id="pppromocode_start" name="pppromocode_start" type="date" placeholder="(MM/DD/YYYY)" class="pppromo_datepicker" value="" /><!--img src="'.plugins_url('/',__FILE__).'images/datepicker.gif" /--></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppromocode_end">'.__('Promo Expiration Date:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input id="pppromocode_end" name="pppromocode_end" type="date" placeholder="(MM/DD/YYYY)" class="pppromo_datepicker" value="" /><!--img src="'.plugins_url('/',__FILE__).'images/datepicker.gif" /--></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppromocode_type">'.__('Discount Type:', 'paypal-promo-plugin-locale').'<br/><span style="font-size:12px;font-style:italic;">'.__('(choose one)', 'paypal-promo-plugin-locale').'</span></label></th>
					<td>
					<input id="pppromocode_type" name="pppromocode_type" type="radio" value="1" /> <span style="font-size:11px;">'.__('% OFF <em>(i.e., 10% Off the item)</em>', 'paypal-promo-plugin-locale').'</span><br/>
					<input id="pppromocode_type" name="pppromocode_type" type="radio" value="2" checked /> <span style="font-size:11px;">'.apply_filters('paypal-promo-price-symbol',__('$','paypal-promo-plugin-locale'),$currency_code).__(' Amt OFF <em>(i.e., 5.00 Off the item)</em>', 'paypal-promo-plugin-locale').'</span><br/>
					<input id="pppromocode_type" name="pppromocode_type" type="radio" value="3" onclick="quickPPcheck();" /> <span style="font-size:11px;">'.__('Set Price ', 'paypal-promo-plugin-locale').apply_filters('paypal-promo-price-symbol',__('$','paypal-promo-plugin-locale'),$currency_code).__(' <em>(i.e., a final price of 7.99)</em>', 'paypal-promo-plugin-locale').'</span>
					</td>
				</tr>
				<tr>
					<th scope="row"><label for="pppromocode_val">'.__('Discount Value:', 'paypal-promo-plugin-locale'). '<br/><span style="font-size:12px;font-style:italic;">'. __('(for above type)', 'paypal-promo-plugin-locale').'</span></label></th>
					<td><input id="pppromocode_val" name="pppromocode_val" type="text" placeholder="i.e., 5.00 (positive value)" value="" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppromocode_prod">'.__('Assign Code to:', 'paypal-promo-plugin-locale').'</label></th>
					<td>
						'.($nobuttons ? 'No Buttons setup. Please setup a button first.' : '<span style="font-size:12px;font-style:italic;">Pick buttons to assign to promo code.</span><br/>' ).'
						<select id="pppromocode_prod" multiple="multiple" name="pppromocode_prod[]" title="'.__('Click to Select', 'paypal-promo-plugin-locale').'" '.($nobuttons ? ' style="display:none;"' : '' ).'>
							'.implode("\n",$button_options).'
						</select>
					</td>
				</tr>
			  </tbody>
			</table>
			<p class="submit"><input type="submit" '.($nobuttons ? 'disabled="disabled"' : '' ).' name="pppcode_addnew" value="'.__('Add PayPal PromoCode', 'paypal-promo-plugin-locale').'" class="button button-primary"  /> <input type="button" value="'.__('Cancel', 'paypal-promo-plugin-locale').'" name="pppcodebtn_cancel" id="pppcodebtn_cancel" class="button button-secondary" onclick="document.location.href=\'?page=pppromo-page\';" /></p>
			</form>
			';
		if($echo)
			echo $addnewpppcode;
		else
			return $addnewpppcode;
	}
	
	function pppcode_edit($ppid){
	/* edit PayPal PromoCode form */
		global $wpdb;
		$table_name 	= $wpdb->prefix . "pppromo";
		$table_name2 	= $wpdb->prefix . "pppromoproducts";
		$getppid2		= $wpdb->get_row("SELECT ppid,ppname,description,ppdiscount,ppdiscounttype,exclude,sdate,edate,wasused FROM $table_name WHERE ppid = $ppid");
		
		echo '<h2>'.__('Edit PayPal PromoCode', 'paypal-promo-plugin-locale').'</h2>';
		echo '<p>'.__('Edit Promo Code Below. See Help in top right of screen for information on each field.', 'paypal-promo-plugin-locale').'</p>';
		echo '<p><hr noshade color="#C0C0C0" size="1"></p>';
		$pppCheckedButtons 	= unserialize($getppid2->description);
		$pppButtons 		= $wpdb->get_results('SELECT * FROM '.$table_name2.' order by pid DESC');
		$button_options 	= array();
		foreach ($pppButtons as $button_row){
			$button_options[] = "\t\t\t\t\t\t\t".'<option value="'.$button_row->pid.'" '.checkifinarray($button_row->pid,$pppCheckedButtons).'>'.$button_row->item_name.' ( $'.$button_row->amount.' )</option>"';
		}
		echo '
		<form name="pppaddcode" action="?page=ppaddcode&mode=pppcodeeditdo" method="post" id="pppaddcode"> 
			<input id="ppid" name="ppid" type="hidden" value="'.stripslashes($getppid2->ppid).'"/>
			<table class="form-table">
			  <tbody>
				<tr>
					<th scope="row"><label for="pppromocode_name">'.__('Enter a Code:', 'paypal-promo-plugin-locale').'<br/><span style="font-size:12px;font-style:italic;">'.__( '(name, number or combination)', 'paypal-promo-plugin-locale' ).'</span></label></th>
					<td><input id="pppromocode_name" name="pppromocode_name" type="text" placeholder="i.e., tenoff" value="'.esc_attr(stripslashes($getppid2->ppname)).'" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppromocode_start">'.__('Promo Start Date:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input id="pppromocode_start" name="pppromocode_start" type="date" value="'.date('Y-m-d',strtotime($getppid2->sdate)).'" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppromocode_end">'.__('Promo Expiration Date:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input id="pppromocode_end" name="pppromocode_end" type="date" value="'.date('Y-m-d',strtotime($getppid2->edate)).'" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppromocode_type">'.__('Discount Type:', 'paypal-promo-plugin-locale').'<br/><span style="font-size:12px;font-style:italic;">'.__('(choose one)', 'paypal-promo-plugin-locale').'</span></label></th>
					<td>
						<input id="pppromocode_type" name="pppromocode_type" type="radio" value="1" '.checkifchecked(1,(int)$getppid2->ppdiscounttype).' /> <span style="font-size:11px;">'.__('% OFF <em>(i.e., 10% Off the item)</em>', 'paypal-promo-plugin-locale').'</span><br/>
						<input id="pppromocode_type" name="pppromocode_type" type="radio" value="2" '.checkifchecked(2,(int)$getppid2->ppdiscounttype).'/> <span style="font-size:11px;">'.__('Amt OFF <em>(i.e., 5.00 Off the item)</em>', 'paypal-promo-plugin-locale').'</span><br/>
						<input id="pppromocode_type" name="pppromocode_type" type="radio" value="3" '.checkifchecked(3,(int)$getppid2->ppdiscounttype).' onclick="quickPPcheck();" /> <span style="font-size:11px;">'.__('Set Price <em>(i.e., a final price of 7.99)</em>', 'paypal-promo-plugin-locale').'</span>
					</td>
				</tr>
				<tr>
					<th scope="row"><label for="pppromocode_val">'.__('Discount Value:', 'paypal-promo-plugin-locale'). '<br/><span style="font-size:12px;font-style:italic;">'. __('(for above type)', 'paypal-promo-plugin-locale').'</span></label></th>
					<td><input id="pppromocode_val" name="pppromocode_val" type="text" placeholder="i.e., 5.00 (positive value)" value="'.stripslashes($getppid2->ppdiscount).'" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="pppromocode_prod">'.__('Assign Code to:', 'paypal-promo-plugin-locale').'</label></th>
					<td>
						<span style="font-size:12px;font-style:italic;">Pick buttons to assign to promo code.</span><br/>
						<select id="pppromocode_prod" multiple="multiple" name="pppromocode_prod[]" title="'.__('Click to Select', 'paypal-promo-plugin-locale').'">
							'.implode("\n",$button_options).'
						</select>
					</td>
				</tr>
			  </tbody>
			</table>
			<p class="submit"><input type="submit" name="pppcode_editdo" value="'.__('Update PayPal PromoCode', 'paypal-promo-plugin-locale').'" class="button button-primary"  /> <input type="button" value="'.__('Cancel', 'paypal-promo-plugin-locale').'" name="pppcodebtn_cancel" id="pppcodebtn_cancel" class="button button-secondary" onclick="document.location.href=\'?page=pppromo-page\';" /></p>
			</form>
		';
	}
	
	function checkPromoCode($coltocheck,$pptocheck){
		//check to see if PromoCode already exists
		if( (string) $coltocheck != '' && (string) $pptocheck != '' ){
			global $wpdb;
			if( $coltocheck == 'description' )
				$ppCodeCheck = $wpdb->get_results("SELECT `description` FROM `{$wpdb->prefix}pppromo` WHERE `description` like '%s:%:\"{$pptocheck}\";%'");
			else
				$ppCodeCheck = $wpdb->get_results("SELECT `{$coltocheck}` FROM `{$wpdb->prefix}pppromo` WHERE `{$coltocheck}`='{$pptocheck}'");
			if( !$ppCodeCheck )
				return false;
			return true;
		}
		return true;
	}
	
	function pppcodebtn_adminpage() { 
		/* admin Button page display */
		global $wpdb;
		$noshowform	= false;
		$mode 		= isset( $_REQUEST['mode'] ) && $_REQUEST['mode'] != '' ? sanitize_text_field( $_REQUEST['mode'] ) : '';
		$ppid 		= isset( $_REQUEST['ppid'] ) && (int) $_REQUEST['ppid'] != 0 ? (int) $_REQUEST['ppid'] : 0; 
		$addN		= isset( $_REQUEST['pppcodebtn_addnew'] ) && $_REQUEST['pppcodebtn_addnew'] != '' ? sanitize_text_field( $_REQUEST['pppcodebtn_addnew']) : '';
		if( $mode == 'pppcodebtnedit' && $ppid != 0 ) {
			echo '<div class="wrap">';
			$this->pppcodebtn_edit( $ppid );
			$noshowform	= true;
			echo '</div>';
		}
		if ( !$noshowform ){ /* show form to add new PayPal PromoCode */
			echo '<div class="wrap">';
			$this->pppcodebtn_newform();
			echo '</div>';
		}	
	}
	
	function pppcodebtn_newform() { /* add new PayPal Button form */
		global $wpdb;
		echo '<h2>'.__('Add New PayPal Button', 'paypal-promo-plugin-locale').'</h2>';
		echo '<p>' .__('Please fill in the form below. To ADD this PayPal Button to a Post or a Page go to the PP Promo Code page and copy the shortcode out at the end of the item, then paste into the Post or Page content editor.', 'paypal-promo-plugin-locale').'<p>';
		echo '<p>' .__('You can also create a button without having a Promo Code assigned - it will just be a normal PayPal button.', 'paypal-promo-plugin-locale').'</p><hr/>';
		echo '<form action="?page=ppaddbutton&mode=pppcodebtn_addnew" method="post" id="pppaddbutton" name="pppaddbutton">
			<table class="form-table">
			  <tbody>
				<tr>
					<th scope="row"><label for="ppcodebtn_item">'.__('Item/Product Name:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="text" name="ppcodebtn_item" id="ppcodebtn_item" size="45" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_itemnum">'.__('Item Number:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="text" name="ppcodebtn_itemnum" id="ppcodebtn_itemnum" size="20" placeholder="'.__('optional', 'paypal-promo-plugin-locale').'" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_amt">'.__('Amount of Item:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="number" min="1" step="any" placeholder="Enter an Amount" name="ppcodebtn_amt" id="ppcodebtn_amt" size="20" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_ship">'.__('Shipping Required?', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="checkbox" name="ppcodebtn_ship" id="ppcodebtn_ship" value="1" '.checkifchecked(1,(int)getMultiOption('ppp_options','shipping')).' /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_shipamt">'.__('Shipping Amount:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="number" min="1" step="any" placeholder="'.__('optional', 'paypal-promo-plugin-locale').'" name="ppcodebtn_shipamt" id="ppcodebtn_shipamt" size="20" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_specialins">'.__('Allow SPECIAL MESSAGE Box for Customer?', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="checkbox" name="ppcodebtn_specialins" id="ppcodebtn_specialins" value="1" '.checkifchecked(1,(int)getMultiOption('ppp_options','ppcodebtn_specialins', 'false')).' /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_returl">'.__('Return URL<br/>(after successful payment):', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="url" name="ppcodebtn_returl" id="ppcodebtn_returl" placeholder="optional - i.e., '. get_bloginfo('url').'/'.'" size="45" value="'.getMultiOption('ppp_options','returnUrl').'" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_canurl">'.__('Cancel URL<br/>(before payment):', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="url" name="ppcodebtn_canurl" id="ppcodebtn_canurl" placeholder="optional - i.e., '. get_bloginfo('url').'/'.'" size="45" value="'.getMultiOption('ppp_options','cancelUrl').'" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_ccode">'.__('PayPal Currency Code:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="text" name="ppcodebtn_ccode" id="ppcodebtn_ccode" size="20" placeholder="'.__('default USD', 'paypal-promo-plugin-locale').'" value="'.getMultiOption('ppp_options','currencyCode').'" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_type">'.__('Button Type (choose one):', 'paypal-promo-plugin-locale').'</label></th>
					<td><span style="font-size:11px;font-style:italic;display: block;padding-top: 10px;">(images not shown actual size)</span><br/><span style="display: block;max-width: 700px;">'.$this->getPPButtons(1).'</span></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_emailid">'.__('PayPal Email Address or Encrypted ID:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="text" name="ppcodebtn_emailid" id="ppcodebtn_emailid" size="45" value="'.getMultiOption('ppp_options','emailid').'" /></td>
				</tr>
			  </tbody>
			</table>
			<p class="submit"><input type="submit" value="'.__('Add New PayPal Button', 'paypal-promo-plugin-locale').'" name="pppcodebtn_addnew" id="pppcodebtn_addnew" class="button button-primary" /> <input type="button" value="'.__('Cancel', 'paypal-promo-plugin-locale').'" name="pppcodebtn_cancel" id="pppcodebtn_cancel" class="button button-secondary" onclick="document.location.href=\'?page=pppromo-page\';" /></p>
		</form>	';
	}
	
	function pppcodebtn_edit($ppid){ /* edit PayPal Button form */
		global $wpdb;
		$getppid2 	= $wpdb->get_row( "SELECT * FROM `{$wpdb->prefix}pppromoproducts` WHERE `pid` = '{$ppid}' LIMIT 1;" );
		echo '<h2>'.__('Edit PayPal Button', 'paypal-promo-plugin-locale').'</h2>';
		echo '<p>' .__('Edit the PayPal Button in the form below.').'</p>';
		echo '<p>' .__('To insert a button to a Post or Page HTML go to the', 'paypal-promo-plugin-locale').' <a href="'.admin_url('admin.php?page=pppromo-page').'">'.__('PayPalPCode', 'paypal-promo-plugin-locale').'</a> '.__('page and copy the code out at the end of the item, then paste into the Post or Page entry boxes.', 'paypal-promo-plugin-locale').'</p>';
		echo '<hr />';
		echo '
		<form action="?page=ppaddbutton&mode=pppcodebtn_editdo" method="post" id="pppaddbutton2" name="pppaddbutton2">
			<input id="ppid" name="ppid" type="hidden" value="'.esc_attr($getppid2->pid).'" />
			<table class="form-table">
			  <tbody>
				<tr>
					<th scope="row"><label for="ppcodebtn_item">'.__('Item/Product Name:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="text" name="ppcodebtn_item" id="ppcodebtn_item" size="45" value="'.esc_attr($getppid2->item_name).'" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_itemnum">'.__('Item Number:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="text" name="ppcodebtn_itemnum" id="ppcodebtn_itemnum" size="20" value="'.esc_attr($getppid2->item_num).'" />'.__('(optional)', 'paypal-promo-plugin-locale').'</td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_amt">'.__('Amount of Item:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="text" name="ppcodebtn_amt" id="ppcodebtn_amt" size="20" value="'.esc_attr($getppid2->amount).'" /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_ship">'.__('Shipping Required?', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="checkbox" name="ppcodebtn_ship" id="ppcodebtn_ship" value="1" '.checkifchecked(1,(int)$getppid2->shipping).' /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_shipamt">'.__('Shipping Amount:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="text" name="ppcodebtn_shipamt" id="ppcodebtn_shipamt" value="'.esc_attr($getppid2->shipping_amt).'" size="20" />'.__('(optional)', 'paypal-promo-plugin-locale').'</td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_specialins">'.__('Allow SPECIAL MESSAGE Box for Customer?', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="checkbox" name="ppcodebtn_specialins" id="ppcodebtn_specialins" value="1" '.checkifchecked(1,(int)$getppid2->special_instr).' /></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_returl">'.__('Return URL<br/>(after successful payment):', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="text" name="ppcodebtn_returl" id="ppcodebtn_returl" size="45" value="'.esc_url_raw($getppid2->return_url).'" />'.__('(optional)', 'paypal-promo-plugin-locale').'</td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_canurl">'.__('Cancel URL<br/>(before payment):', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="text" name="ppcodebtn_canurl" id="ppcodebtn_canurl" size="45" value="'.esc_url_raw($getppid2->cancel_url).'" />'.__('(optional)', 'paypal-promo-plugin-locale').'</td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_ccode">'.__('PayPal Currency Code:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="text" name="ppcodebtn_ccode" id="ppcodebtn_ccode" size="20" value="'.esc_attr($getppid2->currency_code).'" />'.__('(default is USD)', 'paypal-promo-plugin-locale').'</td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_type">'.__('Button Type (choose one):', 'paypal-promo-plugin-locale').'</label></th>
					<td><span style="font-size:11px;font-style:italic;display: block;padding-top: 10px;">(images not shown actual size)</span><br/><span style="display: block;max-width: 700px;">'.$this->getPPButtons($getppid2->button_type).'</span></td>
				</tr>
				<tr>
					<th scope="row"><label for="ppcodebtn_emailid">'.__('PayPal Email Address or Encrypted ID:', 'paypal-promo-plugin-locale').'</label></th>
					<td><input type="text" name="ppcodebtn_emailid" id="ppcodebtn_emailid" size="45" value="' . esc_attr($getppid2->pp_emailadd) . '"></td>
				</tr>
			  </tbody>
			</table>
			<p class="submit"><input type="submit" value="'.__('Update PayPal Button', 'paypal-promo-plugin-locale').'" name="pppcodebtn_editdo" id="pppcodebtn_editdo" class="button button-primary"> <input type="button" value="'.__('Cancel', 'paypal-promo-plugin-locale').'" name="pppcodebtn_cancel" id="pppcodebtn_cancel" class="button button-secondary" onclick="document.location.href=\'?page=pppromo-page\';"></p>
		</form>	';
	}
	
	function get_current_page(){
		if( is_admin() ){
			return isset( $_REQUEST['page'] ) && $_REQUEST['page'] != '' ? sanitize_text_field( $_REQUEST['page'] ) : 'pppromo-page';
		}
		return 'pppromo-page';
	}
	
	function pppcode_insertnew() {
	/* insert PayPal PromoCode into DB */
		if( !current_user_can('edit_pages') )
			wp_die( __( 'You do not have permission to create new PayPal Promocodes.','paypal-promo-plugin-locale') );
		global $wpdb;
		$ppname 	= isset($_POST['pppromocode_name']) && $_POST['pppromocode_name'] != '' ? sanitize_text_field($_POST['pppromocode_name']) : '';
		$startdate 	= isset($_POST['pppromocode_start']) && $_POST['pppromocode_start'] != '' ? sanitize_text_field($_POST['pppromocode_start']) : '';
		$expdate 	= isset($_POST['pppromocode_end']) && $_POST['pppromocode_end'] != '' ? sanitize_text_field($_POST['pppromocode_end']) : '';
		$ppdiscount = isset($_POST['pppromocode_val']) && $_POST['pppromocode_val'] != '' ? sanitize_text_field($_POST['pppromocode_val']) : '';
		$pptype 	= isset($_POST['pppromocode_type']) && (int) $_POST['pppromocode_type'] != 0 ? (int) $_POST['pppromocode_type']: 0;
		$ppbutton 	= isset($_POST['pppromocode_prod']) && $_POST['pppromocode_prod'] != '' ? (array) $_POST['pppromocode_prod'] : array();
		$ppbutton 	= array_map( 'esc_attr', $ppbutton );
		$sbutt		= serialize($ppbutton);
		$chkdCode	= $this->checkPromoCode( 'ppname', $ppname );
		$msg		= array();
		if ( empty( $ppbutton ) )
			$checkedButton	= $this->checkPromoCode( 'description', '-1' );
		else
			$checkedButton 	= false;
		
		if ( $chkdCode )
			$msg[] = '<span style="color:#FF0000;display:block;">'. __('PromoCode name is already in use. Please change the code to something else.','paypal-promo-plugin-locale').'</span>';
		
		if ( $checkedButton )
			$msg[] = '<span style="color:#FF0000;display:block;">'. __('The selected Button already has a code assigned to it.','paypal-promo-plugin-locale').'</span>';
		
		if( !$chkdCode && !$checkedButton ){
			$results 	= $wpdb->query( "INSERT INTO `{$wpdb->prefix}pppromo` (`ppname`,`sdate`,`edate`,`ppdiscount`,`ppdiscounttype`,`description`,`exclude`) VALUES ('{$ppname}','{$startdate}','{$expdate}','{$ppdiscount}','{$pptype}','{$sbutt}','0');" );
			$url 		= add_query_arg( array('page' => 'pppromo-page', 'mode' => 'pppcode_new_msg',), admin_url('admin.php') );
			wp_redirect( $url, 302 );
			exit;
		}else{
			wp_die(implode("\n",$msg) . __('Please go back and correct.','paypal-promo-plugin-locale'), __('Error!','paypal-promo-plugin-locale'), array( 'back_link' => true ) );
		}
		return true;
	}
	
	function pppcodebtn_insertnew() {
		/* insert PayPal Button into DB */
		if( !current_user_can('edit_pages') )
			wp_die( __( 'You do not have permission to create new PayPal Buttons.','paypal-promo-plugin-locale'));
		global $wpdb;
	    $item_name		= isset($_POST['ppcodebtn_item']) && $_POST['ppcodebtn_item'] != '' ? sanitize_text_field( $_POST['ppcodebtn_item'] ) : '';
		$item_num 		= isset($_POST['ppcodebtn_itemnum']) && $_POST['ppcodebtn_itemnum'] != '' ? sanitize_text_field( $_POST['ppcodebtn_itemnum'] ) : '';
		$special_instr 	= isset($_POST['ppcodebtn_specialins']) && (int) $_POST['ppcodebtn_specialins'] == 1 ? 1 : 0;
		$amount 		= isset($_POST['ppcodebtn_amt']) && is_numeric($_POST['ppcodebtn_amt']) ? round(floatval($_POST['ppcodebtn_amt']),2) : 0;
		$shipping 		= isset($_POST['ppcodebtn_ship']) && (int) $_POST['ppcodebtn_ship'] == 1 ? 1 : 0;
		$shippingamount = isset($_POST['ppcodebtn_shipamt']) && is_numeric($_POST['ppcodebtn_shipamt']) ? round(floatval($_POST['ppcodebtn_shipamt']),2) : 0;
		$return_url 	= isset($_POST['ppcodebtn_returl']) && $_POST['ppcodebtn_returl'] != '' ? esc_url_raw($_POST['ppcodebtn_returl']) : '';
		$cancel_url 	= isset($_POST['ppcodebtn_canurl']) && $_POST['ppcodebtn_canurl'] != '' ? esc_url_raw($_POST['ppcodebtn_canurl']) : '';
		$currency_code 	= isset($_POST['ppcodebtn_ccode']) && strlen($_POST['ppcodebtn_ccode']) == 3 ? sanitize_text_field($_POST['ppcodebtn_ccode']) : 'USD';
		$button_type	= isset($_POST['pppcodebtn_button']) && (int) $_POST['pppcodebtn_button'] > 0 ? (int) $_POST['pppcodebtn_button'] : 99;
		$pp_emailadd 	= isset($_POST['ppcodebtn_emailid']) && $_POST['ppcodebtn_emailid']!= '' ? ( strpos($_POST['ppcodebtn_emailid'],'@') !== false ? sanitize_email($_POST['ppcodebtn_emailid']) : sanitize_text_field( $_POST['ppcodebtn_emailid'] ) ) : '' ;
		$pp_emailadd	= $pp_emailadd == '' ? getMultiOption('ppp_options','emailid','') : $pp_emailadd; //get default value of not set.
		if( $pp_emailadd != '' ){
			$results 		= $wpdb->query( "INSERT INTO `{$wpdb->prefix}pppromoproducts` ( `item_name`, `item_num` ,`special_instr` ,`amount`, `shipping`, `shipping_amt`, `return_url`, `cancel_url`, `currency_code`, `button_type`, `pp_emailadd` ) VALUES ('{$item_name}','{$item_num}','{$special_instr}','{$amount}','{$shipping}','{$shippingamount}','{$return_url}','{$cancel_url}','{$currency_code}','{$button_type}','{$pp_emailadd}');" );
			$url 			= add_query_arg( array('page' => 'pppromo-page', 'mode' => 'pppcodebtn_new_msg',), admin_url('admin.php') );
			wp_redirect( $url, 302 );
			exit;
		}else{
			wp_die( __('You need to have a PayPal email address or an ID set in the button or in the options to be able to add a button.','paypal-promo-plugin-locale'), __('Error!','paypal-promo-plugin-locale'), array( 'back_link' => true ) );
		}
	}

	function pppcode_removetst($ppid) {
	/* delete PayPal PromoCodes from DB */
		if( !current_user_can('edit_pages') )
			wp_die( __( 'You do not have permission to delete PayPal Promocodes.','paypal-promo-plugin-locale' ) );
		if( $ppid == '' || $ppid == '0' || !is_numeric( $ppid ) )
			return;
		global $wpdb;
		$results	= $wpdb->query( "DELETE FROM `{$wpdb->prefix}pppromo` WHERE `ppid` = '{$ppid}';" );
		$url 		= add_query_arg( array('page' => 'pppromo-page', 'mode' => 'pppcode_rem_msg',), admin_url('admin.php') );
		wp_redirect( $url, 302 );
		exit;
	}
	
	function pppcodebtn_removetst($ppid) { 
	/* delete PayPal Buttons from DB */
		if( !current_user_can('edit_pages') )
			wp_die( __( 'You do not have permission to delete PayPal Buttons.','paypal-promo-plugin-locale' ));
		if($ppid == '' || $ppid == '0' || !is_numeric( $ppid ) )
			return;
		global $wpdb;
		$results 	= $wpdb->query( "DELETE FROM `{$wpdb->prefix}pppromoproducts` WHERE `pid` = '{$ppid}';" );
		$url 		= add_query_arg( array('page' => 'pppromo-page', 'mode' => 'pppcodebtn_rem_msg',), admin_url('admin.php') );
		wp_redirect( $url, 302 );
		exit;
	}

	function pppcode_editdo($ppid){
	/* update PayPal PromoCode in DB */
		if( !current_user_can('edit_pages') )
			wp_die( __( 'You do not have permission to update PayPal Promocodes.','paypal-promo-plugin-locale' ) );
		if($ppid == '' || $ppid == '0' || !is_numeric( $ppid ) )
			return;
		global $wpdb;
		$ppname 	= isset($_POST['pppromocode_name']) && $_POST['pppromocode_name'] != '' ? sanitize_text_field( $_POST['pppromocode_name'] ): '';
		$startdate 	= isset($_POST['pppromocode_start']) && $_POST['pppromocode_start'] != '' ? sanitize_text_field( $_POST['pppromocode_start'] ): '';
		$expdate 	= isset($_POST['pppromocode_end']) && $_POST['pppromocode_end'] != '' ? sanitize_text_field( $_POST['pppromocode_end'] ): '';
		$ppdiscount	= isset($_POST['pppromocode_val']) && $_POST['pppromocode_val'] != '' ? sanitize_text_field( $_POST['pppromocode_val'] ): '';
		$pptype 	= isset($_POST['pppromocode_type']) && (int) $_POST['pppromocode_type'] != 0 ? (int) $_POST['pppromocode_type']: 0;
		$ppbutton 	= isset($_POST['pppromocode_prod']) && $_POST['pppromocode_prod'] != '' ? (array) $_POST['pppromocode_prod'] : array();
		$ppbutton 	= array_map( 'esc_attr', $ppbutton );
		$serbutt	= serialize($ppbutton);
		if( $startdate != '' && $expdate != '' ){
			$results 	= $wpdb->query("UPDATE `{$wpdb->prefix}pppromo` SET `ppname` = '{$ppname}', `sdate` = '{$startdate}', `edate` = '{$expdate}', `ppdiscount` = '{$ppdiscount}', `ppdiscounttype` = '{$pptype}', `description` = '{$serbutt}' WHERE `ppid` = '{$ppid}' LIMIT 1;");
			$url 		= add_query_arg( array('page' => 'pppromo-page', 'mode' => 'pppcode_edit_msg',), admin_url('admin.php') );
			wp_redirect( $url, 302 );
			exit;
		}else{
			wp_die( __( 'You need to have a Promocode Name, Start Date, Expiration Date and Discount Value. Please check your data.','paypal-promo-plugin-locale' ), __( 'Error!','paypal-promo-plugin-locale' ),array('back_link'=>true));
		}
	}
	
	function pppcodebtn_editdo($ppid){ 
	/* update PayPal Button in DB */
		if( !current_user_can('edit_pages') )
			wp_die( __( 'You do not have permission to update PayPal Buttons.','paypal-promo-plugin-locale' ) );
		if($ppid == '' || $ppid == '0' || !is_numeric( $ppid ) )
			return;
		global $wpdb;
	    $item 			= isset($_POST['ppcodebtn_item']) && $_POST['ppcodebtn_item'] != '' ? sanitize_text_field( $_POST['ppcodebtn_item'] ) : '';
		$item_num 		= isset($_POST['ppcodebtn_itemnum']) && $_POST['ppcodebtn_itemnum'] != '' ? sanitize_text_field( $_POST['ppcodebtn_itemnum'] ) : '';
		$special_instr 	= isset($_POST['ppcodebtn_specialins']) && (bool) $_POST['ppcodebtn_specialins'] == true ? 1 : 0;
		$amount 		= isset($_POST['ppcodebtn_amt']) && is_numeric($_POST['ppcodebtn_amt']) ? round(floatval($_POST['ppcodebtn_amt']),2) : 0;
		$shipping 		= isset($_POST['ppcodebtn_ship']) && (bool) $_POST['ppcodebtn_ship'] == true ? 1 : 0;
		$shippingamount = isset($_POST['ppcodebtn_shipamt']) && is_numeric($_POST['ppcodebtn_shipamt']) ? round(floatval($_POST['ppcodebtn_shipamt']),2) : 0;
		$return_url 	= isset($_POST['ppcodebtn_returl']) && $_POST['ppcodebtn_returl'] != '' ? esc_url_raw($_POST['ppcodebtn_returl']) : '';
		$cancel_url 	= isset($_POST['ppcodebtn_canurl']) && $_POST['ppcodebtn_canurl'] != '' ? esc_url_raw($_POST['ppcodebtn_canurl']) : '';
		$currency_code 	= isset($_POST['ppcodebtn_ccode']) && strlen($_POST['ppcodebtn_ccode']) == 3 ? sanitize_text_field($_POST['ppcodebtn_ccode']) : 'USD';
		$button_type	= isset($_POST['pppcodebtn_button']) && (int) $_POST['pppcodebtn_button'] > 0 ? (int) $_POST['pppcodebtn_button'] : 99;
		$pp_emailadd 	= isset($_POST['ppcodebtn_emailid']) && $_POST['ppcodebtn_emailid']!= '' ? ( strpos($_POST['ppcodebtn_emailid'],'@') !== false ? sanitize_email($_POST['ppcodebtn_emailid']) : sanitize_text_field( $_POST['ppcodebtn_emailid'] ) ) : '' ;
		$pp_emailadd	= $pp_emailadd == '' ? getMultiOption('ppp_options','emailid','') : $pp_emailadd; //get default value of not set.
		if( $pp_emailadd != '' ){
			//need an email address or ID in order to use it.
			$SQLis 		= "UPDATE `{$wpdb->prefix}pppromoproducts` SET `item_name`= '{$item}', `item_num` = '{$item_num}', `special_instr` = '{$special_instr}', `amount` = '{$amount}', `shipping` = '{$shipping}', `shipping_amt` = '{$shippingamount}', `return_url` = '{$return_url}', `cancel_url` = '{$cancel_url}', `currency_code` = '{$currency_code}', `button_type` = '{$button_type}', `pp_emailadd` = '{$pp_emailadd}' WHERE `pid` = '{$ppid}' LIMIT 1;";
			$results	= $wpdb->query($SQLis);
			$url 		= add_query_arg( array('page' => 'pppromo-page', 'mode' => 'pppcodebtn_edit_msg',), admin_url('admin.php') );
			wp_redirect( $url, 302 );
			exit;
		}else{
			wp_die( __( 'You need to have a PayPal email address or an ID set in the button or in the options to be able to add a button.','paypal-promo-plugin-locale' ), __( 'Error!','paypal-promo-plugin-locale' ), array( 'back_link' => true ) );
		}
	}
	
	function update_pppcounts($option_name=''){
		if( $option_name == '' )
			return;
		$oldcount =  $this->get_pppcounts($option_name);
		$newcount = $oldcount + 1;
		update_option($option_name, $newcount);
	}
	
	function get_pppcounts($option_name=''){
		if ( get_option($option_name) != '') {
			$thecount =  (int)get_option($option_name);
		} else {
			$thecount = 0;
		}
		return $thecount;
	}

	function paypal_button_post_type_init() {
	  $labels_button = array(
	    'name' =>  __( 'PayPal Button', 'paypal-promo-plugin-locale' ),
	    'singular_name' =>  __( 'PayPal Button', 'paypal-promo-plugin-locale' ),
	    'add_new' =>  __( 'Add New', 'paypal-promo-plugin-locale' ),
	    'add_new_item' =>  __( 'Add New PayPal Button', 'paypal-promo-plugin-locale' ),
	    'edit_item' =>  __( 'Edit PayPal Button', 'paypal-promo-plugin-locale' ),
	    'new_item' =>  __( 'New PayPal Button', 'paypal-promo-plugin-locale' ),
	    'all_items' =>  __( 'All PayPal Buttons', 'paypal-promo-plugin-locale' ),
	    'view_item' =>  __( 'View PayPal Button', 'paypal-promo-plugin-locale' ),
	    'search_items' =>  __( 'Search PayPal Buttons', 'paypal-promo-plugin-locale' ),
	    'not_found' =>   __( 'No PayPal Buttons Found', 'paypal-promo-plugin-locale' ),
	    'not_found_in_trash' =>  __( 'No PayPal Buttons found in Trash', 'paypal-promo-plugin-locale' ), 
	    'parent_item_colon' => '',
	    'menu_name' =>  __( 'PayPal Buttons', 'paypal-promo-plugin-locale' )
	  );
	
	  $args_button = array(
	    'labels' => $labels_button,
	    'public' => false,
	    'publicly_queryable' => false,
	    'show_ui' => true, 
	    'show_in_menu' => true, 
	    'query_var' => true,
	    'rewrite' => array( 'slug' => 'paypal-button' ),
	    'capability_type' => 'post',
	    'has_archive' => false, 
	    'hierarchical' => false,
	    'menu_position' => null,
	    'supports' => array( 'title', 'editor', 'author', 'thumbnail', 'excerpt')
	  ); 
	  
	  $labels_promo = array(
	    'name' => __( 'PayPal Promo Code', 'paypal-promo-plugin-locale' ),
	    'singular_name' => __( 'PayPal Promo Code', 'paypal-promo-plugin-locale' ),
	    'add_new' => __( 'Add New', 'paypal-promo-plugin-locale' ),
	    'add_new_item' => __( 'Add New PayPal Promo Code', 'paypal-promo-plugin-locale' ),
	    'edit_item' => __( 'Edit PayPal Promo Code', 'paypal-promo-plugin-locale' ),
	    'new_item' => __( 'New PayPal Promo Code', 'paypal-promo-plugin-locale' ),
	    'all_items' => __( 'All PayPal Promo Codes', 'paypal-promo-plugin-locale' ),
	    'view_item' => __( 'View PayPal Promo Code', 'paypal-promo-plugin-locale' ),
	    'search_items' => __( 'Search PayPal Promo Codes', 'paypal-promo-plugin-locale' ),
	    'not_found' =>  __( 'No PayPal Promo Codes Found', 'paypal-promo-plugin-locale' ),
	    'not_found_in_trash' => __( 'No PayPal Promo Codes found in Trash', 'paypal-promo-plugin-locale' ), 
	    'parent_item_colon' => '',
	    'menu_name' => __( 'PayPal Promo Codes', 'paypal-promo-plugin-locale' )
	  );
	
	  $args_promo = array(
	    'labels' => $labels_promo,
	    'public' => false,
	    'publicly_queryable' => false,
	    'show_ui' => true, 
	    'show_in_menu' => true, 
	    'query_var' => true,
	    'rewrite' => array( 'slug' => 'paypal-promo' ),
	    'capability_type' => 'post',
	    'has_archive' => false, 
	    'hierarchical' => false,
	    'menu_position' => null,
	    'supports' => array( 'title', 'editor', 'author', 'thumbnail', 'excerpt')
	  ); 
	
	  register_post_type( 'paypal-button', $args_button );
	  register_post_type( 'paypal-promo', $args_promo );
	}
	
	function paypal_button_updated_messages( $messages ) {
	  global $post, $post_ID;
	  $messages['paypal-button'] = array(
	    0 => '',
	    1 => sprintf( __('PayPal Button updated. <a href="%s">View PayPal Button</a>', 'paypal-promo-plugin-locale'), esc_url( get_permalink($post_ID) ) ),
	    2 => __('Custom field updated.', 'paypal-promo-plugin-locale'),
	    3 => __('Custom field deleted.', 'paypal-promo-plugin-locale'),
	    4 => __('PayPal Button updated.', 'paypal-promo-plugin-locale'),
	    /* translators: %s: date and time of the revision */
	    5 => isset($_GET['revision']) ? sprintf( __('PayPal Button restored to revision from %s', 'paypal-promo-plugin-locale'), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
	    6 => sprintf( __('PayPal Button published. <a href="%s">View PayPal Button</a>', 'paypal-promo-plugin-locale'), esc_url( get_permalink($post_ID) ) ),
	    7 => __('PayPal Button saved.', 'paypal-promo-plugin-locale'),
	    8 => sprintf( __('PayPal Button submitted. <a target="_blank" href="%s">Preview PayPal Button</a>', 'paypal-promo-plugin-locale'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
	    9 => sprintf( __('PayPal Button scheduled for: <strong>%1$s</strong>. <a target="_blank" href="%2$s">Preview PayPal Button</a>', 'paypal-promo-plugin-locale'),
	      // translators: Publish box date format, see http://php.net/date
	      date_i18n( __( 'M j, Y @ G:i' ,'paypal-promo-plugin-locale' ), strtotime( $post->post_date ) ), esc_url( get_permalink($post_ID) ) ),
	    10 => sprintf( __('PayPal Button draft updated. <a target="_blank" href="%s">Preview PayPal Button</a>', 'paypal-promo-plugin-locale'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
	  );
	  $messages['paypal-promo'] = array(
	    0 => '',
	    1 => sprintf( __('PayPal Promocode updated. <a href="%s">View PayPal Promocode</a>', 'paypal-promo-plugin-locale'), esc_url( get_permalink($post_ID) ) ),
	    2 => __('Custom field updated.', 'paypal-promo-plugin-locale'),
	    3 => __('Custom field deleted.', 'paypal-promo-plugin-locale'),
	    4 => __('PayPal Promocode updated.', 'paypal-promo-plugin-locale'),
	    /* translators: %s: date and time of the revision */
	    5 => isset($_GET['revision']) ? sprintf( __('PayPal Promocode restored to revision from %s', 'paypal-promo-plugin-locale'), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
	    6 => sprintf( __('PayPal Promocode published. <a href="%s">View PayPal Promocode</a>', 'paypal-promo-plugin-locale'), esc_url( get_permalink($post_ID) ) ),
	    7 => __('PayPal Promocode saved.', 'paypal-promo-plugin-locale'),
	    8 => sprintf( __('PayPal Promocode submitted. <a target="_blank" href="%s">Preview PayPal Promocode</a>', 'paypal-promo-plugin-locale'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
	    9 => sprintf( __('PayPal Promocode scheduled for: <strong>%1$s</strong>. <a target="_blank" href="%2$s">Preview PayPal Promocode</a>', 'paypal-promo-plugin-locale'),
	      // translators: Publish box date format, see http://php.net/date
	      date_i18n( __( 'M j, Y @ G:i','paypal-promo-plugin-locale' ), strtotime( $post->post_date ) ), esc_url( get_permalink($post_ID) ) ),
	    10 => sprintf( __('PayPal Promocode draft updated. <a target="_blank" href="%s">Preview PayPal Promocode</a>', 'paypal-promo-plugin-locale'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
	  );
	  return $messages;
	}
	
	function paypal_button_add_help_tabs (){
		$screen = get_current_screen();
		if( 'toplevel_page_pppromo-page' == $screen->id){
			$screen->add_help_tab( array(
			'id'		=> 'overview',
			'title'		=> __('Overview', 'paypal-promo-plugin-locale'),
			'content'	=>
				'<p>' . __('This plugin documentation is not complete. Please visit :<a href="http://www.fischercreativemedia.com/wordpress-plugins/paypal-promo-code-plugin/">http://www.fischercreativemedia.com/wordpress-plugins/paypal-promo-code-plugin/</a> for updates and more information as it becomes available.', 'paypal-promo-plugin-locale') . '</p>' .
				'<p><strong>' . __('Types of Buttons Allowed', 'paypal-promo-plugin-locale') .'</strong>'.
				'<br/>'.__('Currently, this plugin only allows for Buy Now, Pay Now, Donation and Add to Cart buttons. ', 'paypal-promo-plugin-locale') . '<br/>' .
				'<br/><span class="pppr_help_note">' . __('NOTE: There is some functionality for Subscription buttons in the code, but it has NOT been tested and you will have to modify the code yourself to accomplish this. Hopefully in a future update it will be turned on. If you MUST to use a subscription button and you do not know basic programming in PHP and do not know how to modify a plugin, then this plugin is NOT for you. This is basically an unsupported plugin, which means that any requests for changes or modifications will be replied with an estimate of the cost to achieve the desired functionality. If you are having a problem, I\'ll try to help out is time allows, but I am very busy and free projects are at the very bottom of my priority list. If you can wait a bit, it may eventually be added to the plugin core.', 'paypal-promo-plugin-locale') . '</span></p>'
				) );
			$screen->add_help_tab( array(
			'id'		=> 'adding-buttons',
			'title'		=> __('Adding Buttons', 'paypal-promo-plugin-locale'),
			'content'	=>
				'<p><strong>' . __('Adding Buttons to Pages/Posts/Widgets', 'paypal-promo-plugin-locale') .'</strong>'.
				'<br/>'.__('PayPal PromoCode allows you to easily add your buttons to a Post, a Page or a text Widget in the sidebar by using a place-holder shortcode ( i.e., <code>[paypalpromo id=1]</code> ).', 'paypal-promo-plugin-locale') . '</p>' .
				'<blockquote>' . __('<u>For Pages/Posts:</u> Once you create the button, copy the code for the button and paste it into the editor for the Page/Post you want the button and update. There is no need to place the code in the HTML View section, as long as you do not format it in the Visual WYSIWYG mode. You can add as many buttons as you want to a page and you can add the same button in several places if you choose to do so (great for long posts or multi-page posts). ', 'paypal-promo-plugin-locale') . '</p>' .
				'<p>' . __('<u>For Widgets:</u> Add a new TEXT Widget to your sidebar (or use an existing one) and paste the button code in the textarea and save. ', 'paypal-promo-plugin-locale') . '</p>' .
				'<p>' . __('<u>Remember:</u> If you add a new button and want a specific promocode to work with it, you must add that button to the promo code button list - newly created buttons are not added to promocodes automatically. ', 'paypal-promo-plugin-locale') . '</p></blockquote>' .
				'<p><strong>' . __('Adding a View Cart Button', 'paypal-promo-plugin-locale') . '</strong>'.
				'<br/>'.__('If you are using Add To Cart buttons, you can add a View Cart button any where you like. The shortcode to add the view cart button is <code>[pppviewcart]</code> an can be placed any where you can add the shortcode for buttons (Pages/Posts or Widget textarea).', 'paypal-promo-plugin-locale') . '</p>' .
				'<p><strong>' . __('Adding Promo Codes', 'paypal-promo-plugin-locale') . '</strong>'.
				'<br/>'.__('Click the Add New Promo Code in the menu and enter all the information. (more information coming soon)', 'paypal-promo-plugin-locale') . '</p>'
			) );
			$screen->add_help_tab( array(
			'id'		=> 'tracking-buttons',
			'title'		=> __('Promo Code Tracking', 'paypal-promo-plugin-locale'),
			'content'	=>
				'<p>' . __('<strong>Promo Code Tracking</strong>', 'paypal-promo-plugin-locale') .
				'<br/>'.__('Basic Promo Code Tracking (the number of times a promo code is used) is from version 1.5.2 forward.', 'paypal-promo-plugin-locale') . '</p>'
			) );
			$screen->add_help_tab( array(
			'id'		=> 'custom-styles',
			'title'		=> __('Custom Styles', 'paypal-promo-plugin-locale'),
			'content'	=>
				'<p>' . __('<strong>Using your own Styles</strong>', 'paypal-promo-plugin-locale') .
				'<br/>'.__('This plugin uses a default style sheet. If you wish to use your own styles, simply copy the <code>pppcode-styles.css</code> file from the plugin directory and place it in your theme diretory. Then edit the styles as you need to. This will keep the styles intact should you upgrade in the future.', 'paypal-promo-plugin-locale') . '</p>'
			) );
			$screen->add_help_tab( array(
			'id'		=> 'using-promocodes',
			'title'		=> __('Using Promo Codes', 'paypal-promo-plugin-locale'),
			'content'	=>
				'<p>' . __('<strong>Using Promo Codes</strong>', 'paypal-promo-plugin-locale') . '</p>' .
				'<p>' . __('PromoCodes can be used two ways, either by telling the customer to use PromoCode <code>YourCodeName</code> (this would be whatever name you give it) or by adding the <code>&amp;</code> or <code>?</code> and <code>pppcode=YourCodeName</code> to the end of the url that you want to direct customers to. ', 'paypal-promo-plugin-locale') . '</p>' .
				'<p>' . __('For example:', 'paypal-promo-plugin-locale') .
				'<br/>'.__('<code>http://donfischer.com/?pppcode=YourCodeName</code> would take them to the home page of your site and set the PromoCode session. Now when they visit any page that has a button that was created using this plugin, the PromoCode will be applied (granted the promo code applies to that button).', 'paypal-promo-plugin-locale') . '</p>'
			) );
			$screen->set_help_sidebar(
				'<p><strong>' . __('For more information:', 'paypal-promo-plugin-locale') . '</strong></p>' .
				'<p>' . __('<a href="http://www.fischercreativemedia.com/donations/" target="_blank">Donate to this Plugin</a>', 'paypal-promo-plugin-locale') . '</p>' .
				'<p>' . __('<a href="http://www.fischercreativemedia.com/wordpress-plugins/" target="_blank">See Our Other WordPress Plugins</a>', 'paypal-promo-plugin-locale') . '</p>'
			);

	  }elseif( 'paypal-codes_page_ppaddset' == $screen->id ){
			$screen->add_help_tab( array(
			'id'		=> 'settings',
			'title'		=> __('Settings', 'paypal-promo-plugin-locale'),
			'content'	=>
				'<p><strong>' . __('Email Address/Secure Merchant Account ID', 'paypal-promo-plugin-locale') . '</strong><br/>'.	__('<em>Required</em>. The PayPal Email Address or Secure Merchant Account ID is either the email address associated with PayPal or the PayPal Secure Merchant Account ID. The Secure Merchant Account ID can be retreived from the button code generated on PayPal\'s site using this method.', 'paypal-promo-plugin-locale') . '</p>' .
				'<p><strong>' . __('Return URL', 'paypal-promo-plugin-locale') . '</strong><br/>'.	__('<em>Optional</em>. The Return URL is populated based on the blog URL by default. You can adjust it if you want a custom Return URL (where you are directed when you complete a PayPal transaction or press continue shopping).', 'paypal-promo-plugin-locale') . '</p>' .
				'<p><strong>' . __('Cancel URL', 'paypal-promo-plugin-locale') . '</strong><br/>'.	__('<em>Optional</em>. The Cancel URL is populated based on the blog URL by default. You can adjust it if you want a custom Cancel URL (where you are directed when you click cancel on PayPal during the transaction).', 'paypal-promo-plugin-locale') . '</p>' .
				'<p><strong>' . __('Shipping Info Needed', 'paypal-promo-plugin-locale') . '</strong><br/>'.	__('<em>Optional</em>. If Shipping information is needed for the product/item, chcking this will make PayPal ask for shipping information.', 'paypal-promo-plugin-locale') . '</p>' .
				'<p><strong>' . __('Allow SPECIAL MESSAGE', 'paypal-promo-plugin-locale') . '</strong><br/>'.	__('<em>Optional</em>. Checking this will make PayPal show a field for the customer to add a special message to the seller(You) at checkout. This option is only shown in the default settings and is not available during button creation.', 'paypal-promo-plugin-locale') . '</p>' .
				'<p><strong>' . __('PayPal ', 'paypal-promo-plugin-locale') . '</strong><br/>'.	__('<em>Optional</em>. If you have a <a target="_blank" href="https://www..paypal.com/">PayPal </a> test account, you can test the button and promocode functionality. Check the box for Test Mode Only and then add you sanbox testing email address in the PayPal Email address field. Be sure to log into your PayPal  account before trying to test the buttons in testing mode.', 'paypal-promo-plugin-locale') . '</p>'.
				'<p><strong>' . __('IPN Notices', 'paypal-promo-plugin-locale') . '</strong><br/>'.	__('<em>Optional</em>. If you DO NOT want PayPal to send back IPN (Instant Payment Notifications), then check this box. If unchecked, PayPal will send information back to this plugin when a transaction is complete and that data will be stored in the database as a record of the transaction..', 'paypal-promo-plugin-locale') . '</p>'
			) );
			$screen->set_help_sidebar(
				'<p><strong>' . __('For more information:', 'paypal-promo-plugin-locale') . '</strong></p>' .
				'<p>' . __('<a href="http://www.fischercreativemedia.com/donations/" target="_blank">Donate to this Plugin</a>', 'paypal-promo-plugin-locale') . '</p>' .
				'<p>' . __('<a href="http://www.fischercreativemedia.com/wordpress-plugins/" target="_blank">See Our Other WordPress Plugins</a>', 'paypal-promo-plugin-locale') . '</p>'
			);
	  }elseif( 'paypal-codes_page_ppaddcode' == $screen->id  ){
			$screen->add_help_tab( array(
			'id'		=> 'settings',
			'title'		=> __('Promo Code Fields', 'paypal-promo-plugin-locale'),
			'content'	=>
				'<p>'.__('To add a new PromoCode, enter the PromoCode Name in the <strong>Enter a Code</strong> field (can be Number or Letters in any combination) for example, <code>VIP2008</code> or <code>10202008</code>. It is recommended that you do not enter any spaces or special characters (%$-_)', 'paypal-promo-plugin-locale').
				'<p>'.__('<strong>Start Date</strong> and <strong>End Date</strong> are the dates the promotion is to start and end.','paypal-promo-plugin-locale').'</p>'.
				'<p>'.__('<strong>Discount Type</strong> can be either <strong>%OFF </strong>(fixed percent off), <strong>$OFF</strong> (fixed dollar amount off) or a <strong>Set Price$</strong> (set dicount price of $X.XX).','paypal-promo-plugin-locale').'</p>'.
				'<p>'.__('<strong>Discount Value</strong> is: 1). The percent off, if <code>%OFF</code> type is choosen, 2). The Dollar amount off if <code>$OFF</code> type is choosen or 3). The new price of the item if <code>Set Price$</code> is choosen. ','paypal-promo-plugin-locale').'</p>'.
				'<p>'.__('<strong>Button to attach the code to</strong>, is the button that discount should apply to. You can choose <strong>ALL</strong> if you want a discount for all buttons (i.e., 15% Off any item on the site), or the actual button. ','paypal-promo-plugin-locale').'</p>'.
				'<p>'.__('Note: if the <strong>Discount Type</strong> of <code>Set Price$</code> is choosen, the button selection cannot be all.','paypal-promo-plugin-locale').'</p>'.
				'<p>'.__('Additional notes: PromoCodes are not case sensitive (vip2008 is the same as VIP2008); Before you can add a promocode, a button must be added. All fields are required','paypal-promo-plugin-locale').'</p>'		
			) );
			$screen->set_help_sidebar(
				'<p><strong>' . __('For more information:', 'paypal-promo-plugin-locale') . '</strong></p>' .
				'<p>' . __('<a href="http://www.fischercreativemedia.com/donations/" target="_blank">Donate to this Plugin</a>', 'paypal-promo-plugin-locale') . '</p>' .
				'<p>' . __('<a href="http://www.fischercreativemedia.com/wordpress-plugins/" target="_blank">See Our Other WordPress Plugins</a>', 'paypal-promo-plugin-locale') . '</p>'
			);
	  }elseif( 'paypal-codes_page_pptrack' == $screen->id  ){
			$screen->add_help_tab( array('id'=> 'settings','title'=> __('Promo Code Tracking', 'paypal-promo-plugin-locale'),'content'=> '<p>'.__('Need to add HELP', 'paypal-promo-plugin-locale')));
			$screen->set_help_sidebar(
				'<p><strong>' . __('For more information:', 'paypal-promo-plugin-locale') . '</strong></p>' .
				'<p>' . __('<a href="http://www.fischercreativemedia.com/donations/" target="_blank">Donate to this Plugin</a>', 'paypal-promo-plugin-locale') . '</p>' .
				'<p>' . __('<a href="http://www.fischercreativemedia.com/wordpress-plugins/" target="_blank">See Our Other WordPress Plugins</a>', 'paypal-promo-plugin-locale') . '</p>'
			);
	  }elseif( 'paypal-codes_page_ppaddbutton' == $screen->id  ){
			$screen->add_help_tab( array(
				'id'=> 'settings',
				'title'=> __('Adding Buttons', 'paypal-promo-plugin-locale'),
				'content'	=>
					'<p>' . __('<strong>Adding Buttons to Pages/Posts/Widgets</strong>', 'paypal-promo-plugin-locale') .
					'<br/>'.__('PayPal PromoCode allows you to easily add your buttons to a Post, a Page or a text Widget in the sidebar by using a place-holder shortcode ( i.e., <code>[paypalpromo id=1]</code> ).', 'paypal-promo-plugin-locale') . '</p>' .
					'<blockquote>' . __('<u>For Pages/Posts:</u> Once you create the button, copy the code for the button and paste it into the editor for the Page/Post you want the button and update. There is no need to place the code in the HTML View section, as long as you do not format it in the Visual WYSIWYG mode. You can add as many buttons as you want to a page and you can add the same button in several places if you choose to do so (great for long posts or multi-page posts). ', 'paypal-promo-plugin-locale') . '</p>' .
					'<p>' . __('<p><u>For Widgets:</u> Add a new TEXT Widget to your sidebar (or use an existing one) and paste the button code in the textarea and save. ', 'paypal-promo-plugin-locale') . '</p>' .
					'<p>' . __('<p><u>Remember:</u> If you add a new button and want a specific promocode to work with it, you must add that button to the promo code button list - newly created buttons are not added to promocodes automatically. ', 'paypal-promo-plugin-locale') . '</blockquote>' .
					'<p>' . __('<strong>Adding a View Cart Button</strong>', 'paypal-promo-plugin-locale') .
					'<br/>'.__('If you are using Add To Cart buttons, you can add a View Cart button any where you like. The shortcode to add the view cart button is <code>[pppviewcart]</code> an can be placed any where you can add the shortcode for buttons (Pages/Posts or Widget textarea).', 'paypal-promo-plugin-locale') . '</p>' 
				));
			$screen->set_help_sidebar(
				'<p><strong>' . __('For more information:', 'paypal-promo-plugin-locale') . '</strong></p>' .
				'<p>' . __('<a href="http://www.fischercreativemedia.com/donations/" target="_blank">Donate to this Plugin</a>', 'paypal-promo-plugin-locale') . '</p>' .
				'<p>' . __('<a href="http://www.fischercreativemedia.com/wordpress-plugins/" target="_blank">See Our Other WordPress Plugins</a>', 'paypal-promo-plugin-locale') . '</p>'
			);
	  }
	  
	}
}
global $paypal_promocode_instance;
$paypal_promocode_instance = new PayPalPromoCodePlugin();

//if(!function_exists('date_format')){function date_format($dateval,$dateformat='m\/d\/Y'){if($dateval!=''){return date($dateformat,$dateval);}return $dateval;}}
//if(!function_exists('date_create')){function date_create($dateval=''){if($dateval==''){$dateval="now";}if (strtotime($dateval) === false || strtotime($dateval) === -1) {return strtotime("now");} else { return strtotime($dateval);}}}
if(!function_exists('getMultiOption')){function getMultiOption($optionname,$arrayname,$default=''){ $options = get_option( $optionname, array() );if(isset($options[$arrayname]) && $options[$arrayname] != ''){return $options[$arrayname];}else{return $default;}}}
if(!function_exists('checkifinarray')){function checkifinarray($chkthis,$chkagainst){if(in_array($chkthis,$chkagainst)){return 'selected';}return;}}
if(!function_exists('checkifchecked')){function checkifchecked($chkagainst,$chkthis){$testis = ((int)$chkthis == (int)$chkagainst? true : false);if($testis){return 'checked';}}}
if(!function_exists('checkifselected')){function checkifselected($chkagainst,$chkthis){$testis= (string)$chkthis==(string)$chkagainst;if($testis==1){return 'selected';}}}
if(!function_exists('selfURL')){function selfURL() {$s = empty($_SERVER["HTTPS"]) ? '' : ($_SERVER["HTTPS"] == "on") ? "s" : "";$protocol = strleft(strtolower($_SERVER["SERVER_PROTOCOL"]), "/").$s;$port = ($_SERVER["SERVER_PORT"] == "80") ? "" : (":".$_SERVER["SERVER_PORT"]);return $protocol."://".$_SERVER['SERVER_NAME'].$port.$_SERVER['REQUEST_URI'];}}
if(!function_exists('strleft')){function strleft($s1, $s2) {return substr($s1, 0, strpos($s1, $s2));}}
if(!function_exists('get_curr_symbol')){
	function get_curr_symbol( $sym = "USD", $val = 'code' ){
		$currarray = array(
			'AUD' =>array('name'=>'Australian Dollar','code'=>'&#36;'),
			'BRL' => array('name'=>'Brazilian Real','code'=>'&#82;&#36;'),
			'CAD' => array('name'=>'Canadian Dollar','code'=>'&#36;'),
			'CZK' => array('name'=>'Czech Koruna','code'=>'&#75;&#269;'),
			'DKK' => array('name'=>'Danish Krone','code'=>'kr'),
			'EUR' => array('name'=>'Euro','code'=>'&#8364;'),
			'HKD' => array('name'=>'Hong Kong Dollar','code'=>'&#36;'),
			'HUF' => array('name'=>'Hungarian Forint','code'=>'Ft'),
			'ILS' => array('name'=>'Israeli New Sheqel','code'=>'&#8362;'),
			'JPY' => array('name'=>'Japanese Yen','code'=>'&#165;'),
			'MYR' => array('name'=>'Malaysian Ringgit','code'=>'RM'),
			'MXN' => array('name'=>'Mexican Peso','code'=>'&#36;'),
			'NOK' => array('name'=>'Norwegian Krone','code'=>'kr'),
			'NZD' => array('name'=>'New Zealand Dollar','code'=>'&#36;'),
			'PHP' => array('name'=>'Philippine Peso','code'=>'&#8369;'),
			'PLN' => array('name'=>'Polish Zloty','code'=>'z&#;322'),
			'GBP' => array('name'=>'Pound Sterling','code'=>'&#163;'),
			'SGD' => array('name'=>'Singapore Dollar','code'=>'&#36;'),
			'SEK' => array('name'=>'Swedish Krona','code'=>'kr'),
			'CHF' => array('name'=>'Swiss Franc','code'=>'CHF'),
			'TWD' => array('name'=>'Taiwan New Dollar','code'=>'NT&#36;'),
			'THB' => array('name'=>'Thai Baht','code'=>'&#3647;'),
			'TRY' => array('name'=>'Turkish Lira','code'=>'&#8356;'),
			'USD' => array('name'=>'U.S. Dollar','code'=>'&#36;')
		);
		return $currarray[ $sym ][ $val ];
	}
}

// Old filters & Action helpers
function do_callback_getPPButtonUrlshort($url = ''){return apply_filters('pppcode-button-url-short',$url);}
add_action( 'getPPButtonUrlshort','do_callback_getPPButtonUrlshort', -10, 1 );
function do_callback_pppcode_updatesettings($ppp_options = array()){return apply_filters('pppcode-update-settings',$ppp_options);}
add_filter( 'pppcode-updatesettings','do_callback_pppcode_updatesettings', -10, 1 );
function do_callback_paypal_promo_price_symbol($symbol = '&#36;',$curcode = ''){return apply_filters('pppcode-price-symbol',$symbol, $curcode);}
add_filter( 'paypal-promo-price-symbol','do_callback_paypal_promo_price_symbol', -10, 2 );
function do_callback_ppp_default_options($ppp_options = array()){return apply_filters('pppcode-default-options',$ppp_options);}
add_filter( 'ppp_default_options','do_callback_ppp_default_options', -10, 1 );
function do_callback_make_pppviewcart($form = '', $buttonUrlshort = '',$buttonUrl = '', $pp_emailadd = '' ){return apply_filters('pppcode-make-pppviewcart', $form, $buttonUrlshort, $buttonUrl, $pp_emailadd );}
add_filter( 'make_pppviewcart','do_callback_make_pppviewcart', -10, 4 );
